;=====================================================
;MAIN ATYPEX.DLL SOURCE CODE FILE
;=====================================================
ATX_VERSION		equ	'1.61'

;=================================================================
format PE GUI 4.0 DLL at 1500000h
entry DllEntryPoint
;=================================================================

include '%fasminc%\WIN32A.INC'	;must have FASM environment variable set properly for this
include 'Data\constants.inc'
include 'Data\atxonlyconstants.inc'
include 'Data\macros.inc'
include 'Data\initrtmacros.inc'
include 'Data\customstrucs.inc'
include 'Data\strucs.inc'
include 'Data\ddraw.inc'
include 'Data\MaxActiveDinos\mad_macros.inc'
include 'Data\MaxActiveDinos\mad_maindata.inc'
include 'Data\virtualdata.inc'
include 'Data\classoutputterstrucsconstants.inc'


;=================================================================
section '.code' code readable executable
;=================================================================

	call CheckFacingBetweenInstanceAndTarget
;-----------------------------------
DllEntryPoint:
;-----------------------------------

	mov eax,[esp+8]
	cmp eax,DLL_PROCESS_ATTACH
	    jz LoadDLLCode
	cmp eax,DLL_PROCESS_DETACH
	    jz FREE_MEM_1
	mov eax,TRUE
	ret 12

;-----------------------------------
FREE_MEM_1:
;-----------------------------------
;free possibly loaded buffers and delete temporary files

	LOCALRELEASENONULL [currentbitmap]
	LOCALRELEASENONULL [CAnimalBuffer]
	LOCALRELEASENONULL [CAnimal_JUMP_Info_BUF]
	call ResetPlayerPathTraces
	call ReleaseAnimalProjBuffer
	call ReleaseFIXOBJECTSPEEDmainbuffer
	LOCALRELEASENONULL [NewDinoVocalsBuffer]
	LOCALRELEASENONULL [MAD_NewBuffer]
	LOCALRELEASENONULL [HINT_NEW_STRING_ADDR]
	call CBACKDROPBUFFERRELEASE
	call COutP_Release
	cmp [UseHUD],0
	    jz No_ReleaseHUD_FREEMEM
	call ReleaseHUD
	No_ReleaseHUD_FREEMEM:

	push esi
	push edi
		mov edi,[MapsPathSize]
		add edi,DDF_FN_Buffer
		mov esi,MAINSCREEN_TEMP_FILE_NAMEONLY
		call TransferString
	invoke DeleteFile,DDF_FN_Buffer

		mov edi,[MapsPathSize]
		add edi,DDF_FN_Buffer
		mov esi,RENDER_TEMP_FILE_NAMEONLY
		call TransferString
	invoke DeleteFile,DDF_FN_Buffer
	pop edi
	pop esi

	call ReleaseAllAVIBuffers

	mov eax,TRUE
	ret 12

;-----------------------------------
include 'INIT_RT\_INIT_RT_PROCS.inc'
;-----------------------------------

;initializes DLL for specific Trespasser EXE
;Note: ATYPEX.dll cannot be loaded from any other EXE than
;one of the four supported 1.1 Trespasser EXEs
;=================================================================
LoadDLLCode:
;=================================================================
	mov eax,[esp+4]
	mov [DLLHandle],eax

	call CreateLogFile

	push esi
	push edi
	push ebp
	push ebx

	xor ebp,ebp		;ebp -> used for error logging

include 'INIT_RT\_DETECT_EXE.inc'
include 'INIT_RT\_MAIN_SET.inc'

ExitInit:

	pop ebx
	pop ebp
	pop edi
	pop esi
	xor eax,eax
	test [DLLLoadSuccessBool],1
	     setz al		 ;return load DLL success/error
	ret 12

;=================================================================

;Main ActionType functions
include 'ActionTypes\_INAT.inc'
include 'ActionTypes\AT100_MXTTimed.inc'
include 'ActionTypes\AT101_MXTSet.inc'
include 'ActionTypes\AT102_LoadNewMap.inc'
include 'ActionTypes\AT103_ReloadGun.inc'
include 'ActionTypes\AT104_PlayerHealth.inc'
include 'ActionTypes\AT105_PlaySMKVideo.inc'
include 'ActionTypes\AT106_LoadNewHint.inc'
include 'ActionTypes\AT107_ATXDRVStart.inc'
include 'ActionTypes\AT108_ATXDRVStop.inc'
include 'ActionTypes\AT109_SetDefaultCParticlesColors.inc'
include 'ActionTypes\AT110_SetObjectFixedSpeed.inc'
include 'ActionTypes\AT111_EndObjectFixedSpeed.inc'
include 'ActionTypes\AT112_SetKeysMouseState.inc'
include 'ActionTypes\AT113_SetPlayerAITypeValue.inc'
include 'ActionTypes\AT114_RandomizedInstanceTeleport.inc'
include 'ActionTypes\AT115_UseObject.inc'
include 'ActionTypes\AT116_DinoJumpCall.inc'

;Explicitly enabled hacks/cheats/other
include 'RT\_MAIN_CHEATS.inc'
include 'RT\_RT_PROCS.inc'
include 'RT\_RT_PROCS_3DNOW.inc'
include 'RT\_RT_PROCS_SSE.inc'
include 'RT\ACTJUMPNEW.inc'
include 'RT\ANIMALPROJECTILE.inc'
include 'RT\ATXDRV.inc'
include 'RT\BACK_BUFFER_DRAW_MAIN.inc'
include 'RT\CBACKDROPENDINITINTRCPT.inc'
include 'RT\CLASSOUTPUTTER.inc'
include 'RT\CPARTICLES.inc'
include 'RT\DINOVOCALPROCNEW.inc'
include 'RT\DISPLAY_CANIMAL.inc'
include 'RT\DISPLAY_HUD.inc'
include 'RT\DISPLAY_LINST.inc'
include 'RT\DISPLAY_MAP.inc'
include 'RT\DISPLAY_MISC.inc'
include 'RT\DISPLAY_TIME_FPS_DD_KEYS_HP_GSPD.inc'
include 'RT\DISPLAY_TRACES.inc'
include 'RT\DDRAWENUM.inc'
include 'RT\DDRAWMAIN.inc'
include 'RT\DRAWDISTRT.inc'
include 'RT\ENDLEVELLOAD.inc'
include 'RT\ERRORCOUNT.inc'
include 'RT\FIXSPEED.inc'
include 'RT\FLYMODE.inc'
include 'RT\FOGSKYRENDER.inc'
include 'RT\FOLLOWDINO.inc'
include 'RT\GLOBALCLUTDEFAULT.inc'
include 'RT\HINTMOD.inc'
include 'RT\KEYHANDLER.inc'
include 'RT\LOADINITIALBITMAP.inc'
include 'RT\LEVELLOADBG_EXT.inc'
include 'RT\MAX_ACTIVE_DINOS_RT.inc'
include 'RT\MENU_MOD.inc'
include 'RT\MOUSEMVTHANDLER.inc'
include 'RT\NIGHTMODETELEPORTS.inc'
include 'RT\ON_ACTBITE.inc'
include 'RT\PRELEVELLOAD.inc'
include 'RT\PRERENDERINTERCEPT.inc'
include 'RT\QUICKSAVE.inc'
include 'RT\RANDOM_INSTANCES.inc'
include 'RT\RAYCASTPROCS.inc'
include 'RT\RECORD.inc'
include 'RT\SAVEMAPSTATE.inc'
include 'RT\THIRDP.inc'
include 'RT\TPAINTERCEPT.inc'
include 'RT\TRESSTRDBG.inc'

;=================================================================
section '.data' data readable writeable
;=================================================================

include 'Data\exedata.inc'
include 'Data\generaldata.inc'
include 'Data\inidata.inc'
include 'Data\initrtdata.inc'

;=================================================================
section '.idata' import data readable writeable
;=================================================================

  library kernel,"KERNEL32.DLL",\
	  user32,"USER32.DLL",\
	  gdi,"GDI32.DLL",\
	  msvcrt,"MSVCRT.DLL",\
	  winmm,"WINMM.DLL"

  import kernel,\
	 CloseHandle,"CloseHandle",\
	 CopyFile,"CopyFileA",\
	 CreateFile,"CreateFileA",\
	 CreateFileMapping,"CreateFileMappingA",\
	 DeleteFile,"DeleteFileA",\
	 ExitProcess,"ExitProcess",\
	 FindClose,"FindClose",\
	 FindFirstFile,"FindFirstFileA",\
	 FlushFileBuffers,"FlushFileBuffers",\
	 FlushInstructionCache,"FlushInstructionCache",\
	 FreeLibrary,"FreeLibrary",\
	 GetCurrentProcessId,"GetCurrentProcessId",\
	 GetFileSize,"GetFileSize",\
	 GetLastError,"GetLastError",\
	 GetModuleFileName,"GetModuleFileNameA",\
	 GetPrivateProfileInt,"GetPrivateProfileIntA",\
	 GetPrivateProfileSection,"GetPrivateProfileSectionA",\
	 GetPrivateProfileSectionNames,"GetPrivateProfileSectionNamesA",\
	 GetPrivateProfileString,"GetPrivateProfileStringA",\
	 GetProcAddress,"GetProcAddress",\
	 GetSystemInfo,"GetSystemInfo",\
	 GetTickCountTRUE,"GetTickCount",\
	 IsBadReadPtr,"IsBadReadPtr",\
	 IsBadStringPtr,"IsBadStringPtrA",\
	 IsBadWritePtr,"IsBadWritePtr",\
	 LoadLibrary,"LoadLibraryA",\
	 LocalAlloc,"LocalAlloc",\
	 LocalFree,"LocalFree",\
	 LocalReAlloc,"LocalReAlloc",\
	 LocalSize,"LocalSize",\
	 MapViewOfFile,"MapViewOfFile",\
	 OpenProcess,"OpenProcess",\
	 ReadFile,"ReadFile",\
	 SetEndOfFile,"SetEndOfFile",\
	 SetFileAttributes,"SetFileAttributesA",\
	 SetFilePointer,"SetFilePointer",\
	 UnmapViewOfFile,"UnmapViewOfFile",\
	 VirtualAlloc,"VirtualAlloc",\
	 VirtualFree,"VirtualFree",\
	 VirtualProtect,"VirtualProtect",\
	 VirtualProtectExTRUE,"VirtualProtectEx",\
	 WriteFile,"WriteFile",\
	 WritePrivateProfileString,"WritePrivateProfileStringA",\
	 WriteProcessMemory,"WriteProcessMemory"

  import user32,\
	 DestroyWindow,"DestroyWindow",\
	 FindWindow,"FindWindowA",\
	 CloseWindow,"CloseWindow",\
	 DrawText,"DrawTextA",\
	 GetActiveWindow,"GetActiveWindow",\
	 GetAsyncKeyState,"GetAsyncKeyState",\
	 GetCursorPos,"GetCursorPos",\
	 GetDC,"GetDC",\
	 GetDesktopWindow,"GetDesktopWindow",\
	 KillTimer,"KillTimer",\
	 LoadBitmap,"LoadBitmapA",\
	 LoadString,"LoadStringA",\
	 MessageBox,"MessageBoxA",\
	 ReleaseDC,"ReleaseDC",\
	 SendMessage,"SendMessageA",\
	 SetFocus,"SetFocus",\
	 SetForegroundWindow,"SetForegroundWindow",\
	 SetTimer,"SetTimer",\
	 ShowCursor,"ShowCursor",\
	 ShowWindow,"ShowWindow",\
	 UpdateWindow,"UpdateWindow",\
	 VkKeyScan,"VkKeyScanA",\
	 wsprintf,"wsprintfA"

  import gdi,\
	 BitBlt,"BitBlt",\
	 CreateCompatibleDC,"CreateCompatibleDC",\
	 CreateDIBSection,"CreateDIBSection",\
	 DeleteDC,"DeleteDC",\
	 DeleteObject,"DeleteObject",\
	 SelectObject,"SelectObject",\
	 SetDIBitsToDevice,"SetDIBitsToDevice",\
	 SetPixelV,"SetPixelV",\
	 SetStretchBltMode,"SetStretchBltMode",\
	 SetTextColor,"SetTextColor",\
	 StretchBlt,"StretchBlt",\
	 TextOut,"TextOutA"

  import msvcrt,\
	 free,"free",\
	 msize,"_msize",\
	 rand,"rand",\
	 sprintf,"sprintf",\
	 srand,"srand",\
	 sscanf,"sscanf",\
	 time,"time",\
	 YAPAXI,"??2@YAPAXI@Z"		 ;a.k.a. "operator new"

  import winmm,\
	 mciSendString,"mciSendStringA"

;=================================================================
section '.edata' export data readable
;=================================================================
	export 'ATYPEX.DLL',\
		INAT,'INAT'	;not used - included for compatibility only

;=================================================================
section '.rsrc' resource data readable
;=================================================================

	directory RT_BITMAP,bmps,\
		  RT_VERSION,versions

	resource bmps,\
		 100,LANG_NEUTRAL,blinkerbmp,\
		 101,LANG_NEUTRAL,aimdotbmp,\
		 102,LANG_NEUTRAL,tracesbmp

	resource versions,\
	   1,LANG_NEUTRAL,version

	bitmap blinkerbmp,"BLINKER.bmp"
	bitmap aimdotbmp,"AIMDOT.bmp"
	bitmap tracesbmp,"TRACES.bmp"

	versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,\
				LANG_ENGLISH+SUBLANG_DEFAULT,0,\
	  'FileDescription','Part of ATX Trespasser modification',\
	  'LegalCopyright','Free, open source.',\
	  'FileVersion',ATX_VERSION,\
	  'ProductVersion',ATX_VERSION,\
	  'OriginalFilename','ATYPEX.DLL'

;=================================================================
section '.reloc' fixups data discardable readable
;=================================================================
