;object:
;DWORD [object] = VTable Pointer
;DWORD [object+4] = n/a
;DWORD [object+8] = Slow game speed (Matrix-style)
;DWORD [object+12] = interval
;DWORD [object+16] = not used
;DWORD [object+20] = run once value
;       bit 0 = should be run only once?
;       bit 1 = has been run once? (only valid if bit 0 set)
;DWORD [object+24] = initial run once value (for re-init)
;DWORD [object+28] = enter transition interval
;DWORD [object+32] = exit transition interval

struct CAT100
       lpVTable 		dd	?
       refCount 		dd	?
       SlowGameSpeed		dd	?
       Interval 		dd	?
       Reserved1		dd	?
       Flags			dd	?
       InitialFlags		dd	?
       EnterTransInterval	dd	?
       ExitTransInterval	dd	?
ends

align 16
;==========================================================
AT100MAIN:
;==========================================================
cmp [BIONICWOMAN_enabled],1
    jz RunAlreadyOnce100
cmp BYTE [ecx+20],3
    jz RunAlreadyOnce100
	or BYTE [ecx+20],2	;set run once bit (no matter if not used)
push edi
mov edi,ecx

	call MXTGetCurrentTransitionState
	cmp eax,1
	    jz AT100MAIN_InEnterTrans
	cmp eax,2
	    jz AT100MAIN_InEffect
	cmp eax,3
	    jz AT100MAIN_InExitTrans	   ;(preserves edx)

;(assume as if effect disabled if none of the above are set)
	mov edx,[edi+12]
	mov eax,[edi+8]
	mov [MXTStateInterval],edx
	mov [MXTSlowSpeedCurrent],eax
	fld [NormalGameSpeed]
	fsub [MXTSlowSpeedCurrent]
	fstp [MXTSpeedVariationCurrent]

	invoke GetTickCount
	mov [MXTLastTick],eax
	mov ecx,[edi+28]
	mov eax,[edi+32]
	mov [MXTEnterTransitionInterval],ecx
	mov [MXTExitTransitionInterval],eax
	mov [MXTStateEnabled],1

pop edi
RunAlreadyOnce100:
ret

AT100MAIN_InEnterTrans:
	mov edx,[edi+12]
	mov eax,[edi+8]
	mov [MXTStateInterval],edx
	mov [MXTSlowSpeedCurrent],eax
	fld [NormalGameSpeed]
	fsub [MXTSlowSpeedCurrent]
	fstp [MXTSpeedVariationCurrent]
	mov eax,[edi+32]
	mov [MXTExitTransitionInterval],eax

pop edi
ret

AT100MAIN_InEffect:
	mov edx,[edi+12]
	mov eax,[edi+8]
	mov [MXTStateInterval],edx
	mov [MXTSlowSpeedCurrent],eax
	fld [NormalGameSpeed]
	fsub [MXTSlowSpeedCurrent]
	fstp [MXTSpeedVariationCurrent]

	invoke GetTickCount
	mov [MXTLastTick],eax
	mov eax,[edi+32]
	mov [MXTEnterTransitionInterval],0     ;if in effect, do not do enter transition
	mov [MXTExitTransitionInterval],eax

pop edi
ret

AT100MAIN_InExitTrans:		;edx = time (tick) to last ActionType's end
;Same as new MXT effect start, but changes last tick setting
;to compensate for unfinished previous exit trans effect
;However, this generally only works for ATs where the entry transition
;time is the same as the exit transition time.

    push edx
	mov edx,[edi+12]
	mov eax,[edi+8]
	mov [MXTStateInterval],edx
	mov [MXTSlowSpeedCurrent],eax
	fld [NormalGameSpeed]
	fsub [MXTSlowSpeedCurrent]
	fstp [MXTSpeedVariationCurrent]

	invoke GetTickCount
    pop edx
	sub eax,edx
	mov [MXTLastTick],eax
	mov ecx,[edi+28]
	mov eax,[edi+32]
	mov [MXTEnterTransitionInterval],ecx
	mov [MXTExitTransitionInterval],eax

pop edi
ret

align 16
;==========================================================
AT100_REINIT:
;==========================================================
mov eax,[ecx+24]	;reset initial runonce value (upon level restart)
mov [ecx+20],eax
mov eax,[esp+4] 	;standard
ret 4

align 16
;====================================================================
_AT100Init:
;====================================================================
ALLOCAT 36
lea eax,[AT100]
mov [edi],eax
    xor ecx,ecx
mov [edi+4],ecx
mov [edi+8],DWORD 0.300000
mov [edi+12],DWORD 4500
mov [edi+16],ecx
mov [edi+20],ecx
mov [edi+28],ecx
mov [edi+32],ecx

GETVALUE Speed,0
SETVALUE value_float,3

GETVALUE Interval,1
SETVALUE value_int,4

GETVALUE Frame,2		;run only once?
SETVALUE value_bool,6

GETVALUE X,3
SETVALUE value_int,8

GETVALUE Y,4
SETVALUE value_int,9

mov eax,[edi+20]
mov [edi+24],eax		;save runonce value (for re-init)

	jmp ExitINAT
