;SETS OBJECT SPEED AND KEEPS SETTING UNTIL AT110 IS CALLED
;- state should be saved to SAVEDMAP files
;- if an object
;object:
;DWORD [obj] = VTable Pointer
;DWORD [obj+4] = n/a
;DWORD [obj+8] = instance name ID (assumes instance exists)
;DWORD [obj+12] = time expiration (milliseconds, int), -1 if not used
;DWORD [obj+16] = X speed component
;DWORD [obj+20] = Y speed component
;DWORD [obj+24] = Z speed component
;BYTE [obj+28] = bool - if true and object is already in fixed speed mode,
;                       will use new settings
;                       if false and object is already in fixed speed mode,
;                       will have no effect

struct CAT110
       lpVTable 		dd	?
       refCount 		dd	?
       InstanceNameID		dd	?
       ExpirationTime		dd	?
       XSpeed			dd	?
       YSpeed			dd	?
       ZSpeed			dd	?
       Flags			dd	?
ends

align 16
;==========================================================
AT110MAIN:
;==========================================================
push esi
push edi
push ebx

	mov esi,[FIXS_mainbuffer]
	mov edi,ecx
	mov ebx,[FIXS_mainbuffer_sizediv2]
	test esi,esi
	mov eax,[edi+AT110Data.InstanceNameID]
	     jz NoAT110MAIN

    ;first, check if this instance name already has an entry in buffer
	AT110MAIN_InstanceNameCheckLoop:
	cmp [esi],eax
	    jnz AT110MAIN_InstanceNameCheckLoop_skip1
	    cmp [edi+AT110Data.ForceBool],FALSE
		jz NoAT110MAIN
		jmp AT110MAIN_CopyNewStrucData
	AT110MAIN_InstanceNameCheckLoop_skip1:
	add esi,4
	cmp esi,[FIXS_mainbuffer_halfend]
	    jb AT110MAIN_InstanceNameCheckLoop

	mov esi,[FIXS_mainbuffer]
	xor eax,eax

	AT110MAIN_FindFreeSlotLoop:
	cmp [esi],eax
	    jz END_AT110MAIN_FindFreeSlotLoop
	add esi,4
	cmp esi,[FIXS_mainbuffer_halfend]
	   jb AT110MAIN_FindFreeSlotLoop
	   jmp NoAT110MAIN
	END_AT110MAIN_FindFreeSlotLoop:

	invoke LocalAlloc,LPTR,sizeof.at110proj_info
	test eax,eax
	mov [esi+ebx],eax
	     jz NoAT110MAIN

	AT110MAIN_CopyNewStrucData:	;esi = pointer to instance name to store
					;[esi+ebx] = pointer to struct space
	mov ebx,[esi+ebx]
	mov edx,[edi+AT110Data.Interval]
	mov eax,[edi+AT110Data.Velocity.X]
	mov [ebx+at110proj_info.TickLeft],edx
	mov [ebx+at110proj_info.Velocity.X],eax
	mov edx,[edi+AT110Data.Velocity.Y]
	mov eax,[edi+AT110Data.Velocity.Z]
	mov [ebx+at110proj_info.Velocity.Y],edx
	mov [ebx+at110proj_info.Velocity.Z],eax

	mov edx,[LocationADDR]
	push [edi+AT110Data.InstanceNameID]
	mov ecx,[edx]
	call [GETOBJFROMSTRINGIDPROC]	    ;this fetches the string ID's associated instance, if existing
					    ;assumes instance is valid
	mov ecx,[edi+AT110Data.InstanceNameID]
	mov [ebx+at110proj_info.Instance],eax	;set instance in struct
	mov [esi],ecx				;set instance name ID in first part of buffer

NoAT110MAIN:
pop ebx
pop edi
pop esi
ret

align 16
;==========================================================
AT110_REINIT:
;==========================================================
mov eax,[esp+4] 	;standard
ret 4

align 16
;====================================================================
_AT110Init:
;====================================================================

GETVALUE Sample,0
SETVALUE2 value_string			   ;(in eax)

	invoke GETTEMPINST_PROC,eax,0,1    ;get projectile instance name ID
	add esp,12
	mov esi,eax

	mov edx,[LocationADDR]
	push esi
	mov ecx,[edx]
	call [GETOBJFROMSTRINGIDPROC]	   ;ensures instance exists in level (not used immediately)
	test eax,eax
	     jz ExitINAT

ALLOCAT 32
xor ecx,ecx
lea eax,[AT110]
mov [edi+AT110Data.lpVTable],eax
mov [edi+AT110Data.RefCount],ecx
mov [edi+AT110Data.InstanceNameID],esi
mov [edi+AT110Data.Interval],-1
mov [edi+AT110Data.Velocity.X],ecx
mov [edi+AT110Data.Velocity.Y],ecx
mov [edi+AT110Data.Velocity.Z],ecx
mov DWORD [edi+AT110Data.ForceBool],TRUE

GETVALUE Interval,1
SETVALUE value_int,4

GETVALUE X,2
SETVALUE value_float,5

GETVALUE Y,3
SETVALUE value_float,6

GETVALUE Z,4
SETVALUE value_float,7

GETVALUE Frame,5
SETVALUE value_bool,8

       ;if success, increment AT110 instance count
	inc [FIXS_numberofAT110instances]

	jmp ExitINAT