;==========================================================
;READS INI FILE AND RETRIEVES VALUES (POST 1.30 VERSION)
;==========================================================
;edi=INI path and filename
;ebx=pointer to current entry info in table

mov edi,StringBuffer
mov edx,[PathStringSize]
add edx,edi
mov [edx],DWORD 'ATXc'
mov [edx+4],DWORD 'onfi'
mov [edx+8],DWORD 'g.in'
mov [edx+12],WORD 0069h

	push esi
	     mov esi,StringBuffer
	     mov edi,ATXconfiginiFN
	     call TransferString
	pop esi

	mov eax,[PathStringSize]
	mov BYTE [eax+StringBuffer],0

;---------------------------------
;for DDF file path
	push esi
	     mov esi,MapsDirBuffer
	     mov edi,DDF_FN_Buffer
	     call TransferString
	pop esi
;---------------------------------
	mov edi,ATXconfiginiFN

;call CheckForINIExistence

mov ebx,INI_ENTRIES_TABLE

	INIEntriesMainLoop:
	call DWORD [ebx]
	add ebx,20
	cmp ebx,INI_ENTRIES_TABLE_END
	    jb INIEntriesMainLoop

jmp OverINIFunctions
;==========================================================
INI_INT_PROC:
invoke GetPrivateProfileInt,[ebx+4],[ebx+8],[ebx+12],edi
       mov edx,[ebx+16]
       mov [edx],eax
ret
;==========================================================
INI_FLOAT_PROC:
invoke GetPrivateProfileFloat,[ebx+4],[ebx+8],[ebx+12],edi
       mov edx,[ebx+16]
       mov [edx],eax
ret
;==========================================================
INI_STR_PROC:
invoke GetPrivateProfileString,[ebx+4],[ebx+8],[ebx+12],[ebx+16],50,edi
ret
;==========================================================
INI_STR_EXT_PROC:
invoke GetPrivateProfileString,[ebx+4],[ebx+8],[ebx+12],[ebx+16],200,edi
ret
;==========================================================
INI_STR_EXTMAX_PROC:
invoke GetPrivateProfileString,[ebx+4],[ebx+8],[ebx+12],[ebx+16],MAX_PATH,edi
ret
;==========================================================
INI_KEY_PROC:
sub esp,4
    mov eax,esp
invoke GetPrivateProfileString,[ebx+4],[ebx+8],ZERO_STRING,eax,4,edi
    pop eax
       cmp al,30h
	   jz Exit_INI_KEY_PROC
       cmp al,';'
	   jz Exit_INI_KEY_PROC

       CHAR_TOLOWERCASE al

       mov edx,[ebx+16]
       and eax,0FFh
       mov [edx],eax
Exit_INI_KEY_PROC:
ret
;==========================================================
INI_HEX_PROC:
invoke GetPrivateProfileString,[ebx+4],[ebx+8],[ebx+12],stack_ext_buffer,12,edi

invoke sscanf,stack_ext_buffer,ObjCheat_HEX_STR,[ebx+16]
       add esp,12
ret
;==========================================================
CheckForINIExistence:
push ebp
mov ebp,esp
sub esp,100

invoke FindFirstFile,edi,find_data_buf
       cmp eax,INVALID_HANDLE_VALUE
	   jz INIDoesNotExist

mov esp,ebp
pop ebp
ret

INIDoesNotExist:
invoke FindClose,eax

mov ebx,INI_ENTRIES_TABLE

	NewINIEntriesLoop:
	mov edx,[ebx+12]
	cmp DWORD [ebx],INI_INT_PROC
	    jnz Not_INT_VALUE_INI
	    lea eax,[ebp-100]
	invoke wsprintf,eax,_integer,edx
	    add esp,12
	    lea edx,[ebp-100]
	Not_INT_VALUE_INI:
	invoke WritePrivateProfileString,[ebx+4],[ebx+8],edx,edi
	add ebx,20
	cmp ebx,INI_ENTRIES_TABLE_END
	    jb NewINIEntriesLoop
mov esp,ebp
pop ebp
ret

;==========================================================
INI_CHECKNEWHOTKEYSINITPROC:
;==========================================================
;SCANS FOR CHEAT HOTKEYS AND CREATES PROC TABLE FOR KEY HANDLER
;must be called only after all cheats have been set up

push esi
push edi
push ebx

	mov esi,Cheattable    ;8 bytes per cheat
	mov ebx,CHEATJUMPINDEX
	mov edi,CheatHotKeyTableRT

	mov eax,[TotalCheats]
	push eax
	cmp eax,DefaultTotalNumberOfCheats
	    ja CheatHotKeysINIScanLoopEXIT

	CheatHotKeysINIScanLoop:

    ;DWORD [esi] = pointer to cheat string name = name of key
	sub esp,4
	mov eax,esp
	invoke GetPrivateProfileString,section_hotkeys,[esi],ZERO_STRING,eax,4,ATXconfiginiFN
	pop eax
	and eax,0FFh
	test al,al
	     jz CheatHotKeysINIScanLoop_SKIP
	cmp al,30h
	    jz CheatHotKeysINIScanLoop_SKIP
	cmp al,';'
	    jz CheatHotKeysINIScanLoop_SKIP

	CHAR_TOLOWERCASE al

	mov edx,[ebx]		;get callback proc for cheat
	mov [edi+CheatHotKeyTableEntry.KeyValue],eax
	mov [edi+CheatHotKeyTableEntry.ProcAddress],edx

	add edi,sizeof.CheatHotKeyTableEntry ;only add to table if a valid key was found (otherwise, too many empty table members for nothing)

	CheatHotKeysINIScanLoop_SKIP:
	add esi,8
	add ebx,4
	dec DWORD [esp]
	    jnz CheatHotKeysINIScanLoop
	CheatHotKeysINIScanLoopEXIT:

	pop eax

pop ebx
pop edi
pop esi
ret

;==========================================================
OverINIFunctions:

















