align 16
;============================================================
DoAT10JUMPMainEmulInit:
;============================================================
;Note: jump info for instances stored in the jump data buffer
;follow the same instance order as the CAnimalBuffer.
;Jump data buffer is kept separate in case user wants to
;disable it and save a few kilobytes or less of memory.

push ebp
push ebx
push esi
push edi

	LOCALRELEASE [CAnimal_JUMP_Info_BUF]
	mov [BUFSIZE_canimal_jump],0

cmp [UseDisableActJumpNew],0
    jnz NoJUMPCodeInit
cmp [CAnimalBuffer],0
    jz NoJUMPCodeInit

	call GetCAnimalInstanceCount
	mov ecx,sizeof.jump_info
	mul ecx
	push eax
invoke LocalAlloc,LMEM_FIXED,eax
	test eax,eax
	pop ecx
	     jz NoJUMPCodeInit
	mov [BUFSIZE_canimal_jump],ecx
	mov [CAnimal_JUMP_Info_BUF],eax

	mov esi,[LEVELNAME_OBJ] 	 ;SCN level name
	mov edi,MapsDirBuffer
	add edi,[MapsPathSize]
	mov DWORD [edi],'JMP\'		 ;'JMP\' folder for jump data
	add edi,4
	call TransferString
	mov DWORD [edi-4],'.INI'	;modify extension

invoke GetPrivateProfileString,STRING_GENERAL,STRING_PUSH,Push_INIdef,Push_default,50,MapsDirBuffer
invoke GetPrivateProfileString,STRING_GENERAL,STRING_JUMPANGLE,JumpAngle_INIdef,JumpAngle_default,50,MapsDirBuffer
invoke GetPrivateProfileInt,STRING_GENERAL,STRING_JUMPTENDANCY,[JumpTendancy_INIdef],MapsDirBuffer
	mov [JumpTendancy_default],eax
invoke GetPrivateProfileInt,STRING_GENERAL,STRING_REPEATPERIOD,-1,MapsDirBuffer
	mov [RepeatPeriod_default],eax
	mov ebx,eax
invoke GetPrivateProfileInt,STRING_GENERAL,STRING_TENDANCYCHECKPERIOD,-1,MapsDirBuffer
	cmp ebx,-1				;is RepeatPeriod present?
	mov ecx,ebx				;if RepeatPeriod is present, then it becomes default value for TendancyCheckPeriod unless TendancyCheckPeriod is present (checked later)
	    jnz ActJumpNew_RepeatPeriodFound_A
	    mov edx,[RepeatPeriod_INIdef]
	    mov ecx,[TendancyCheckPeriod_INIdef]	;if RepeatPeriod is absent, use ATXconfig.ini default for TendancyCheckPeriod (if this one is not present)
	    mov [RepeatPeriod_default],edx
	ActJumpNew_RepeatPeriodFound_A:

	cmp eax,-1				;is TendancyCheckPeriod present?
	    jnz ActJumpNew_TendancyCheckPeriodFound_A
	    mov eax,ecx 			;if not, used previously-defined default
	ActJumpNew_TendancyCheckPeriodFound_A:
	mov [TendancyCheckPeriod_default],eax

;extra jump condition values (ATX 1.61+)
invoke GetPrivateProfileString,STRING_GENERAL,STRING_MaxBodyTargetDirAngle ,MaxBodyTargetDirAngle_INIdef ,MaxBodyTargetDirAngle_default ,50,MapsDirBuffer
invoke GetPrivateProfileString,STRING_GENERAL,STRING_MaxHeadTargetDirAngle ,MaxHeadTargetDirAngle_INIdef ,MaxHeadTargetDirAngle_default ,50,MapsDirBuffer
invoke GetPrivateProfileString,STRING_GENERAL,STRING_MinTotalVelocity	   ,MinTotalVelocity_INIdef	 ,MinTotalVelocity_default	,50,MapsDirBuffer
invoke GetPrivateProfileString,STRING_GENERAL,STRING_MinDirectionalVelocity,MinDirectionalVelocity_INIdef,MinDirectionalVelocity_default,50,MapsDirBuffer
invoke GetPrivateProfileString,STRING_GENERAL,STRING_MaxDirVelocityAngle   ,MaxDirVelocityAngle_INIdef	 ,MaxDirVelocityAngle_default	,50,MapsDirBuffer
invoke GetPrivateProfileString,STRING_GENERAL,STRING_MinTargetDistance	   ,MinTargetDistance_INIdef	 ,MinTargetDistance_default	,50,MapsDirBuffer
invoke GetPrivateProfileString,STRING_GENERAL,STRING_MaxTargetDistance	   ,MaxTargetDistance_INIdef	 ,MaxTargetDistance_default	,50,MapsDirBuffer

;--------------------
;MAIN SCAN LOOP
;--------------------

	mov ebp,[CAnimal_JUMP_Info_BUF]
	mov ebx,[CAnimalBuffer]

RetrieveJumpValuesLoop:
	mov eax,[ebx+canimal_info.Instance]
	mov edx,[eax+0DCh]	;CBrain
	lea esi,[edx+220h]	;esi=pointer to instance/section name

	mov [ebp+jump_info.Flags],0

invoke GetPrivateProfileFloat,esi,STRING_PUSH,Push_default,MapsDirBuffer
	mov [ebp+jump_info.Push],eax

invoke GetPrivateProfileFloat,esi,STRING_JUMPANGLE,JumpAngle_default,MapsDirBuffer
	push eax
	fld DWORD [esp]
	fmul [pidiv180] 		;convert angle to radians
	fstp [ebp+jump_info.JumpAngle]
	add esp,4

invoke GetPrivateProfileInt,esi,STRING_JUMPTENDANCY,[JumpTendancy_default],MapsDirBuffer
       ;------------
       ;NO JUMPING FOR QUADRUPEDS SETTING (applied via eax)
       ;------------
	cmp [UseDisableQuadrupedJumps],FALSE
	    jz NoUseDisableQuadrupedJumps
	    mov edx,[ebx+canimal_info.Instance]
	    mov ecx,[edx+28h]		;CInfo class
	    mov edx,[ecx+0Ch]		;physics class
	    mov ecx,[edx]		;physics class VTable
	    cmp ecx,[PHINFOQUADRUPEDVTABLE]    ;is quadruped?
		jnz NoUseDisableQuadrupedJumps
		xor eax,eax		;if so, set jump tendancy to null
	NoUseDisableQuadrupedJumps:
       ;------------
	mov [ebp+jump_info.JumpTendancy],eax

invoke GetPrivateProfileInt,esi,STRING_REPEATPERIOD,-1,MapsDirBuffer
	mov ecx,eax
	mov edx,eax
	cmp eax,-1
	    jnz @f
	    mov ecx,[RepeatPeriod_default]
	    mov edx,[TendancyCheckPeriod_default]
	@@:
	mov [ebp+jump_info.RepeatPeriod],ecx
	mov [ebp+jump_info.LastTickCount],0

invoke GetPrivateProfileInt,esi,STRING_TENDANCYCHECKPERIOD,edx,MapsDirBuffer
	mov [ebp+jump_info.TendancyCheckPeriod],eax
	mov [ebp+jump_info.TendancyCheck_LastTick],0

;extra jump condition values (ATX 1.61+)
invoke GetPrivateProfileFloat,esi,STRING_MaxBodyTargetDirAngle ,MaxBodyTargetDirAngle_default ,MapsDirBuffer
	mov [ebp+jump_info.MaxBodyAngleWithTarget],eax
	test eax,eax
	     jz @f
	or [ebp+jump_info.Flags],JUMP_INFO_NEWCOND_MAXBODYANGLE
	fld DWORD [ebp+jump_info.MaxBodyAngleWithTarget]
	fmul [pidiv180]
	fcos
	fstp [ebp+jump_info.MaxBodyAngleWithTarget]
	@@:
invoke GetPrivateProfileFloat,esi,STRING_MaxHeadTargetDirAngle ,MaxHeadTargetDirAngle_default ,MapsDirBuffer
	mov [ebp+jump_info.MaxHeadAngleWithTarget],eax
	test eax,eax
	     jz @f
	or [ebp+jump_info.Flags],JUMP_INFO_NEWCOND_MAXHEADANGLE
	fld [ebp+jump_info.MaxHeadAngleWithTarget]
	fmul [pidiv180]
	fcos
	fstp [ebp+jump_info.MaxHeadAngleWithTarget]
	@@:
invoke GetPrivateProfileFloat,esi,STRING_MinTotalVelocity      ,MinTotalVelocity_default      ,MapsDirBuffer
	mov [ebp+jump_info.MinTotalVelocity],eax
	test eax,eax
	     jz @f
	or [ebp+jump_info.Flags],JUMP_INFO_NEWCOND_MINTOTALSPEED
	fld [ebp+jump_info.MinTotalVelocity]
	fmul st0,st0
	fstp [ebp+jump_info.MinTotalVelocity]
	@@:
invoke GetPrivateProfileFloat,esi,STRING_MinDirectionalVelocity,MinDirectionalVelocity_default,MapsDirBuffer
	mov [ebp+jump_info.MinVelocityDirectional],eax
	test eax,eax
	     jz @f
	or [ebp+jump_info.Flags],JUMP_INFO_NEWCOND_MINDIRSPEED
	;fld [ebp+jump_info.MinVelocityDirectional]     ; NOT ^2
	;fmul st0,st0
	;fstp [ebp+jump_info.MinVelocityDirectional]
	@@:
invoke GetPrivateProfileFloat,esi,STRING_MaxDirVelocityAngle   ,MaxDirVelocityAngle_default   ,MapsDirBuffer
	mov [ebp+jump_info.MaxVelocityDirAngle],eax
	test eax,eax
	     jz @f
	or [ebp+jump_info.Flags],JUMP_INFO_NEWCOND_MAXDIRANGLE
	fld [ebp+jump_info.MaxVelocityDirAngle]
	fmul [pidiv180]
	fcos
	fstp [ebp+jump_info.MaxVelocityDirAngle]
	@@:
invoke GetPrivateProfileFloat,esi,STRING_MinTargetDistance     ,MinTargetDistance_default     ,MapsDirBuffer
	mov [ebp+jump_info.MinTargetDistance],eax
	test eax,eax
	     jz @f
	or [ebp+jump_info.Flags],JUMP_INFO_NEWCOND_MINDISTANCE
	fld [ebp+jump_info.MinTargetDistance]
	fmul st0,st0
	fstp [ebp+jump_info.MinTargetDistance]
	@@:
invoke GetPrivateProfileFloat,esi,STRING_MaxTargetDistance     ,MaxTargetDistance_default     ,MapsDirBuffer
	mov [ebp+jump_info.MaxTargetDistance],eax
	test eax,eax
	     jz @f
	or [ebp+jump_info.Flags],JUMP_INFO_NEWCOND_MAXDISTANCE
	fld [ebp+jump_info.MaxTargetDistance]
	fmul st0,st0
	fstp [ebp+jump_info.MaxTargetDistance]
	@@:

	add ebp,sizeof.jump_info
	add ebx,sizeof.canimal_info
	cmp ebx,[CAnimalBufferEnd]
	    jb RetrieveJumpValuesLoop

	call RANDOMIZE_RANDOM_PROC		;seed randomized value in advance

mov ecx,[MapsPathSize]
mov BYTE [ecx+MapsDirBuffer],0	   ;restore path's null-terminator
NoJUMPCodeInit:
pop edi
pop esi
pop ebx
pop ebp
ret

align 16
;============================================================
ACTJUMPNEW_MAIN:	;ecx=ActBite object (dino-specific), eax = CInfluence
;============================================================
;AT10 object (64 bytes, also add 16 unknown bytes for 'safety'):
;[AT10+00h]      = VTable
;[AT10+00h]      = n/a (set to 0)
;BYTE [AT10+14h] = "Frozen" bool
;[AT10+18h]      = "Target" object
;BYTE [AT10+1Ch] = "Impulse" bool
;[AT10+38h]      = "Push" float
;[AT10+3Ch]      = "Emitter" object
;Note: the Emitter object here uses a CAnimal-type VTable. Only
;its standard methods are used (for all objects), so it will always work
;even though the Emitter is not of CAnimal type class.

push ebp
push edi
push esi
push ebx
push eax
push ecx
								; ecx = CActivityBite class
	;mov ecx,[esp]

	mov ebp,[eax+CInfluence.lpSourceInstance]	       ; ebp = target instance for bite

	mov edx,[CAnimalBuffer]
	mov ebx,[CAnimalBufferEnd]
	test edx,edx
	     jz no_dinojump_code

	FindDinoForActBiteInstanceLoop2:
	mov esi,[edx+canimal_info.Instance]
	mov eax,[esi+0DCh]		;instance's main AI sub-class
	cmp ecx,[eax+18h]		;instance's ActBite sub-class
	    jz END_FindDinoForActBiteInstanceLoop2
	add edx,sizeof.canimal_info
	cmp edx,ebx
	    jb FindDinoForActBiteInstanceLoop2
	    jmp no_dinojump_code
END_FindDinoForActBiteInstanceLoop2:

	mov ebx,[CAnimal_JUMP_Info_BUF]
	mov eax,sizeof.jump_info
	test ebx,ebx
	mov ecx,[edx+canimal_info.Count]
	     jz no_dinojump_code

	mul ecx
	add ebx,eax
	;ebx = dino's jump info, esi = dino object

;-------------------------------------
;INTERVAL CODE
;-------------------------------------

; ensure interval has elapsed (RepeatPeriod)
	invoke GetTickCount
	mov edi,eax
	sub eax,[ebx+jump_info.LastTickCount]
	cmp eax,[ebx+jump_info.RepeatPeriod]
	    jb no_dinojump_code

; ensure interval has elapsed (TendancyCheckPeriod)
	mov eax,edi
	sub eax,[ebx+jump_info.TendancyCheck_LastTick]
	cmp eax,[ebx+jump_info.TendancyCheckPeriod]
	    jb no_dinojump_code
	mov [ebx+jump_info.TendancyCheck_LastTick],edi

; determine if dino is to jump or not (randomly, based on JumpTendancy value)

	stdcall GetRandomNumber,100
	cmp eax,[ebx+jump_info.JumpTendancy]
	    ja no_dinojump_code

; extra jump condition values (ATX 1.61+)
; note: to make ATX display messages for the last "limiting" factors for the last dino jump
;       check/attempt, un-comment the SHOWTEMPMESSAGE instructions
ACTJUMPNEW_MAIN_NEWCONDITIONS:

   ; ebx = dino's jump info, esi = dino object, ebp = target instance ("dest" instance)

	test [ebx+jump_info.Flags],JUMP_INFO_NEWCOND_ALL
	     jz .exitnewconditiontests
	test ebp,ebp
	     jz .exitnewconditiontests

   ; pre-calculate vectors and facing values

	mov eax,[esi+CAnimal.lpCBoundaryBoxHead]
	lea edx,[AJN_DinoHeadFacing]
	lea ecx,[eax+CBoundaryBox.OrientationQuat]
	stdcall CONVERT_TO_FACING_PROC_010,edx,0       ;get head's facing vector

	mov eax,[esi+CAnimal.lpCBoundaryBoxBody]
	lea edx,[AJN_DinoBodyFacing]
	lea ecx,[eax+CBoundaryBox.OrientationQuat]
	stdcall CONVERT_TO_FACING_PROC_010,edx,0       ;get body's facing vector

	fld [ebp+CInstance.Location.X]		       ;get dino-target vector (x-y comp. only) and size
	fsub [esi+CAnimal.Location.X]
	fst [AJN_DinoTargetVector.X]
	fmul st0,st0
	fld [ebp+CInstance.Location.Y]
	fsub [esi+CAnimal.Location.Y]
	fst [AJN_DinoTargetVector.Y]
	fmul st0,st0
	faddp st1,st0
	fstp [AJN_DinoTargetVectorSizeExp2]

	push esi
	mov eax,[esi+28h]
	mov ecx,[eax+0Ch]
	lea eax,[AJN_DinoVelocityVector]
	mov edx,[ecx]
	push eax
	call DWORD [edx+28h]

	fld [AJN_DinoVelocityVector.X]
	fmul st0,st0
	fld [AJN_DinoVelocityVector.Y]
	fmul st0,st0
	faddp st1,st0
	fst [AJN_DinoVelocityVectorSize2DExp2]
	fld [AJN_DinoVelocityVector.Z]
	fmul st0,st0
	faddp st1,st0
	fstp [AJN_DinoVelocityVectorSizeExp2]

   ; begin tests

	test [ebx+jump_info.Flags],JUMP_INFO_NEWCOND_MINDISTANCE
	    jz .nomintargetdistance
  ; SHOWTEMPMESSAGE AJN_lasttest_mindist
	fld [ebx+jump_info.MinTargetDistance]
	fcomp [AJN_DinoTargetVectorSizeExp2]
	fstsw ax
	test ah,FPU_VALUE_BELOW_OR_EQUAL
	     jz no_dinojump_code
	.nomintargetdistance:

	test [ebx+jump_info.Flags],JUMP_INFO_NEWCOND_MAXDISTANCE
	    jz .nomaxtargetdistance
  ;  SHOWTEMPMESSAGE AJN_lasttest_maxdist
	fld [AJN_DinoTargetVectorSizeExp2]
	fcomp [ebx+jump_info.MaxTargetDistance]
	fstsw ax
	test ah,FPU_VALUE_BELOW_OR_EQUAL
	     jz no_dinojump_code
	.nomaxtargetdistance:

	test [ebx+jump_info.Flags],JUMP_INFO_NEWCOND_MINTOTALSPEED
	    jz .nomintotalspeed
  ;  SHOWTEMPMESSAGE AJN_lasttest_minspeed
	fld [AJN_DinoVelocityVectorSizeExp2]	       ; 3d
	fcomp [ebx+jump_info.MinTotalVelocity]
	fstsw ax
	test ah,FPU_VALUE_BELOW
	     jnz no_dinojump_code
	.nomintotalspeed:

	test [ebx+jump_info.Flags],JUMP_INFO_NEWCOND_MINDIRSPEED
	    jz .nominspeeddir	     ; must do sizeof.(projection of velocity vector onto body facing vector) = componentof.() = dot product / magnitude(body vector)  (magnitude is 1.0)
  ;  SHOWTEMPMESSAGE AJN_lasttest_minspeeddir
	fld [AJN_DinoVelocityVector.X]
	fmul [AJN_DinoBodyFacing.X]
	fld [AJN_DinoVelocityVector.Y]
	fmul [AJN_DinoBodyFacing.Y]
	fld [AJN_DinoVelocityVector.Z]
	fmul [AJN_DinoBodyFacing.Z]
	faddp st1,st0
	faddp st1,st0
	fcomp [ebx+jump_info.MinVelocityDirectional]
	fstsw ax
	test ah,FPU_VALUE_BELOW
	     jnz no_dinojump_code
	.nominspeeddir:

	test [ebx+jump_info.Flags],JUMP_INFO_NEWCOND_MAXBODYANGLE
	    jz .nomaxbodytargetangle
  ;  SHOWTEMPMESSAGE AJN_lasttest_maxbodyangle
	push esi
	push edi
	push ebx
	mov eax,[esi+CAnimal.lpCBoundaryBoxBody]
	lea edi,[ebp+CInstance.Location]
	lea esi,[eax+CBoundaryBox.Location]
	lea ebx,[ebx+jump_info.MaxBodyAngleWithTarget]
	call CheckFacingBetweenInstanceAndTarget
	pop ebx
	pop edi
	pop esi
	test al,al
	     jz no_dinojump_code
	.nomaxbodytargetangle:

	test [ebx+jump_info.Flags],JUMP_INFO_NEWCOND_MAXHEADANGLE
	    jz .nomaxheadtargetangle
  ;  SHOWTEMPMESSAGE AJN_lasttest_maxheadangle
	push esi
	push edi
	push ebx
	mov eax,[esi+CAnimal.lpCBoundaryBoxHead]
	lea edi,[ebp+CInstance.Location]
	lea esi,[eax+CBoundaryBox.Location]
	lea ebx,[ebx+jump_info.MaxHeadAngleWithTarget]
	call CheckFacingBetweenInstanceAndTarget
	pop ebx
	pop edi
	pop esi
	test al,al
	     jz no_dinojump_code
	.nomaxheadtargetangle:

	test [ebx+jump_info.Flags],JUMP_INFO_NEWCOND_MAXDIRANGLE
	    jz .nomaxvelocityangle     ; see CheckFacingBetweenInstanceAndTarget for details
   ; SHOWTEMPMESSAGE AJN_lasttest_maxspeedangle
	fld [AJN_DinoBodyFacing.X]
	fmul st0,st0
	fld [AJN_DinoBodyFacing.Y]
	fmul st0,st0
	faddp st1,st0
	fsqrt					       ;sizeof.vector2 (dino body angle on x-y plane only)
	fld [AJN_DinoVelocityVectorSize2DExp2]
	fsqrt					       ;sizeof.vector1 (dino velocity on x-y plane only)
	fmulp st1,st0
	fmul [ebx+jump_info.MaxVelocityDirAngle]       ; cos(b)*sizeof.vector1*sizeof.vector2
	fld [AJN_DinoVelocityVector.X]
	fmul [AJN_DinoBodyFacing.X]
	fld [AJN_DinoVelocityVector.Y]
	fmul [AJN_DinoBodyFacing.Y]
	faddp st1,st0				       ; vector1.vector2
	fcompp					       ; vector1.vector2 >= cos(b)*sizeof.vector1*sizeof.vector2 ?
	fstsw ax
	test ah,FPU_VALUE_BELOW
	     jnz no_dinojump_code		       ; if vector1.vector2 < cos(b)*sizeof.vector1*sizeof.vector2, then angle is above limit, quit
	.nomaxvelocityangle:

.exitnewconditiontests:

; stores tick count for true jump
	mov [ebx+jump_info.LastTickCount],edi	;store last tick count

   ; SHOWTEMPMESSAGE AJN_lasttest_dinojump
; perform jump
	call ForceDinoJump

no_dinojump_code:

pop ecx
pop eax
pop ebx
pop esi
pop edi
pop ebp
ret


align 16
;============================================================
ForceDinoJump:	;esi = CAnimal, ebx = jump_info (neither register is modified)
;============================================================
push ebp
push edi
mov ebp,esp
sub esp,16

	mov edi,AT10_EMITTER_SIM_OBJECT
	mov [edi+4],DWORD 0

	lea ecx,[ebx+jump_info.JumpAngle]	;(stored in radians)
	lea edx,[ebp-16]			;local quat
	call ToLocalQuat_AxisX

	lea eax,[esi+3Ch]			;source quat (rotation - dino's current orientation)
	lea ecx,[ebp-16]			;local quat (to be rotated)
	lea edx,[edi+3Ch]			;result
	call QuaternionMul

	mov eax,[esi+30h]
	mov [edi+30h],eax			;Xposition (Emitter)
	mov eax,[esi+34h]
	mov [edi+34h],eax			;Yposition (Emitter)

	fld DWORD [esi+38h]
	fsub [float_100]
	fstp DWORD [edi+38h]			;Zposition (Emitter)

	mov ecx,AT10_SIM_OBJECT
	mov eax,[ebx+jump_info.Push]
	mov [ecx+04h],DWORD 0
	mov [ecx+18h],esi			;Target
	or BYTE [ecx+1Ch],1			;Impulse
	mov [ecx+38h],eax			;Push (force)
	mov [ecx+3Ch],edi			;Emitter object
	mov edx,0.000000
	mov [ecx+14h],BYTE 0			;Frozen bool
	mov [ecx+08h],edx			;X velocity
	mov [ecx+0Ch],edx			;Y velocity
	mov [ecx+10h],edx			;Z velocity
	mov [ecx+2Ch],edx			;X facing value (axis ???)
	mov [ecx+34h],edx			;Z facing value (???)
	mov eax,[ecx]
	mov [ecx+30h],DWORD 1.000000		;Y facing value (???)
	call DWORD [eax+8]			;AT10 MAIN PROC

mov esp,ebp
pop edi
pop ebp
ret