align 16
;============================================================
DoAnimalProjectileInit:
;============================================================
push ebx
push ebp
push esi
push edi

	call ReleaseAnimalProjBuffer

cmp [CAnimalBuffer],0
    jz NoDoAnimalProjectileInit

	call GetCAnimalInstanceCount
	test eax,eax
	     jz NoDoAnimalProjectileInit

	shl eax,2			;get size of buffer
	mov ebp,eax
	invoke LocalAlloc,LPTR,eax
	test eax,eax
	     jz NoDoAnimalProjectileInit

	mov [animal_projectile_buffer],eax
	mov [animal_projectile_buffer_size],ebp

	mov esi,[LEVELNAME_OBJ] 	 ;SCN level name
	mov edi,MapsDirBuffer
	add edi,[MapsPathSize]
	mov DWORD [edi],'SPT\'		 ;'SPT\' folder for jump data
	add edi,4
	call TransferString
	mov DWORD [edi-4],'.INI'	;modify extension

	mov ebx,[CAnimalBuffer]
	mov esi,[animal_projectile_buffer]

	push DWORD 0			;will be set to 1 if at least one spitter
;scan for values loop
	DoAnimalProjectileInit_LOOP:
	mov eax,[ebx+canimal_info.Instance]
	mov edx,[eax+0DCh]	;CBrain
	lea ebp,[edx+220h]	;esi=pointer to instance/section name

	;scan for projectile names loop (1 - 8)
	    mov edi,1
	    DoAnimalProjectileInit_LOOP_ProjName:
	    invoke wsprintf,stack_ext_buffer,SPTSTR_ProjectileName,edi
	    add esp,12

	    invoke GetPrivateProfileString,ebp,stack_ext_buffer,ZERO_STRING,(stack_ext_buffer+200),200,MapsDirBuffer
	    sub esp,4
	    cmp WORD [(stack_ext_buffer+200)],0030h	 ;'0',0
		jz DoAnimalProjectileInit_LOOP_ProjName_NoProj
		mov eax,(stack_ext_buffer+200)
		call GetInstanceFromStringGlobal
		test eax,eax
		mov [esp],eax
		     jz DoAnimalProjectileInit_LOOP_ProjName_NoProj
		     mov edx,[esi]	;if no buffer, create one
		     test edx,edx
			  jnz DoAnimalProjectileInit_LOOP_ProjName_NoProj_NoNewBuf
			  invoke LocalAlloc,LPTR,sizeof.animproj_info
			  test eax,eax
			  mov edx,eax
			      jz DoAnimalProjectileInit_LOOP_ProjName_NoProj
			  mov [esi],edx
			  lea eax,[edi*4-4-4]		   ;projectile index (will point to -4 for first instance)
			  mov DWORD [esp+4],00000001	   ;at least one spitter
			  mov [edx+animproj_info.NextProjectileIndex],eax
		     DoAnimalProjectileInit_LOOP_ProjName_NoProj_NoNewBuf:
		     mov eax,[esp]		;projectile instance
		     mov [edx+edi*4-4+animproj_info.ProjectileInstance],eax
		     inc [FIXS_numberofSPTprojectile]
		DoAnimalProjectileInit_LOOP_ProjName_NoProj:
		add esp,4

	    inc edi
	    cmp edi,8
		jbe DoAnimalProjectileInit_LOOP_ProjName

	mov edi,[esi]
	test edi,edi				     ;only read other values if there is at least one projectile
	     jz DoAnimalProjectileInit_LOOP_GOTOEND

    ;reset tick count
	mov [edi+animproj_info.LastTick],0

    ;set MinDistanceEXP2
	invoke GetPrivateProfileFloat,ebp,SPTSTR_MinDistance,ZERO_STRING,MapsDirBuffer
	mov [edi+animproj_info.MinDistanceEXP2],eax
	fld [edi+animproj_info.MinDistanceEXP2]
	fmul st0,st0
	fstp [edi+animproj_info.MinDistanceEXP2]

    ;set MinDistanceHorizEXP2
	invoke GetPrivateProfileFloat,ebp,SPTSTR_MinDistanceHoriz,ZERO_STRING,MapsDirBuffer
	mov [edi+animproj_info.MinDistanceHorizEXP2],eax
	fld [edi+animproj_info.MinDistanceHorizEXP2]
	fmul st0,st0
	fstp [edi+animproj_info.MinDistanceHorizEXP2]

    ;set ForwardDistanceFromHead
	invoke GetPrivateProfileFloat,ebp,SPTSTR_ForwardDistanceFromHead,ZERO_STRING,MapsDirBuffer
	mov [edi+animproj_info.DistanceFromHead],eax

    ;set ProjectileSpeed
	invoke GetPrivateProfileFloat,ebp,SPTSTR_ProjectileSpeed,ZERO_STRING,MapsDirBuffer
	mov [edi+animproj_info.ProjectileSpeed],eax

    ;set LaunchProbability
	invoke GetPrivateProfileInt,ebp,SPTSTR_LaunchProbability,100,MapsDirBuffer
	mov [edi+animproj_info.LaunchProbability],eax

    ;set MinLaunchInterval
	invoke GetPrivateProfileInt,ebp,SPTSTR_MinLaunchInterval,3000,MapsDirBuffer
	mov [edi+animproj_info.MinInterval],eax

    ;set ProbabilityInterval
	invoke GetPrivateProfileInt,ebp,SPTSTR_ProbabilityInterval,-1,MapsDirBuffer
	cmp eax,-1
	    jnz ProbabilityInterval_Init_Present
	    mov eax,[edi+animproj_info.MinInterval]
	ProbabilityInterval_Init_Present:
	mov [edi+animproj_info.ProbabilityInterval],eax

    ;set ProjectileExtinguishTime
	invoke GetPrivateProfileInt,ebp,SPTSTR_ProjectileExtinguishTime,-1,MapsDirBuffer
	mov [edi+animproj_info.ProjectileExtinguishTime],eax

    ;set ProjectileZSpeedAdjust
	invoke GetPrivateProfileFloat,ebp,SPTSTR_ProjectileZSpeedAdjust,ZERO_STRING,MapsDirBuffer
	mov [edi+animproj_info.ProjectileZSpeedAdjust],eax

    ;set UseHorizontalAutoAim
	invoke GetPrivateProfileInt,ebp,SPTSTR_UseHorizontalAutoAim,FALSE,MapsDirBuffer
	mov [edi+animproj_info.UseHorizontalAutoAim],al

    ;set UseVerticalAutoAim
	invoke GetPrivateProfileInt,ebp,SPTSTR_UseVerticalAutoAim,FALSE,MapsDirBuffer
	mov [edi+animproj_info.UseVerticalAutoAim],al

    ;set AnimalViewAngle
	invoke GetPrivateProfileFloat,ebp,SPTSTR_AnimalViewAngle,ZERO_STRING,MapsDirBuffer
	mov [edi+animproj_info.AnimalViewAngle],eax
	fld [edi+animproj_info.AnimalViewAngle]
	fmul [pidiv180] 			  ;convert to radians
	fst [edi+animproj_info.AnimalViewAngle]
	fcos
	fstp [edi+animproj_info.AnimalViewAngleCosine]

	DoAnimalProjectileInit_LOOP_GOTOEND:
	add esi,4
	add ebx,sizeof.canimal_info
	cmp ebx,[CAnimalBufferEnd]
	    jb DoAnimalProjectileInit_LOOP

	pop eax
	cmp eax,1			  ;release buffer if no spitters at all
	    jz DoAnimalProjectileInitNORELEASE
	    call ReleaseAnimalProjBuffer
	DoAnimalProjectileInitNORELEASE:

	call RANDOMIZE_RANDOM_PROC		;seed randomized value in advance

mov ecx,[MapsPathSize]
mov BYTE [ecx+MapsDirBuffer],0	   ;restore path's null-terminator
NoDoAnimalProjectileInit:

pop edi
pop esi
pop ebp
pop ebx
ret

align 16
;============================================================
ReleaseAnimalProjBuffer:
;============================================================
push esi
push ebx

       mov esi,[animal_projectile_buffer]
       mov ebx,[animal_projectile_buffer_size]
       test esi,esi
	    jz NoReleaseAnimalProjBuffer2
       test ebx,ebx
	    jz NoReleaseAnimalProjBuffer
       add ebx,esi

       ReleaseAnimalProjBuffer_LOOP:
       mov eax,[esi]
       add esi,4
       test eax,eax
	    jz ReleaseAnimalProjBuffer_LOOP_NotPointer
	    invoke LocalFree,eax
       ReleaseAnimalProjBuffer_LOOP_NotPointer:
       cmp esi,ebx
	   jb ReleaseAnimalProjBuffer_LOOP

NoReleaseAnimalProjBuffer:
	LOCALRELEASE [animal_projectile_buffer]
NoReleaseAnimalProjBuffer2:
	xor eax,eax
	mov [animal_projectile_buffer_size],eax
	mov [FIXS_numberofSPTprojectile],eax

pop ebx
pop esi
ret

align 16
;============================================================
SpitterCode_RT:
;============================================================
push ebp
mov ebp,esp
sub esp,(36+12)
push edi
push esi
push ebx
push eax
push ecx	    ;ecx = CActivityBite instance, eax = CInfluence


;CInfluence object pointer at DWORD [esp+20+16+16]

       ; call RANDOMIZE_RANDOM_PROC
       ; mov ecx,[esp]

	cmp [eax+CInfluence.lpSourceInstance],0
	    jz NO_SpitterCode_RT

	mov edx,[CAnimalBuffer]
	test edx,edx
	mov ebx,[CAnimalBufferEnd]
	     jz NO_SpitterCode_RT

	FindDinoForActBiteInstanceLoop3:
	mov esi,[edx+canimal_info.Instance]
	mov eax,[esi+0DCh]		;instance's main AI sub-class
	cmp ecx,[eax+18h]		;instance's ActBite sub-class
	    jz END_FindDinoForActBiteInstanceLoop3
	add edx,sizeof.canimal_info
	cmp edx,ebx
	    jb FindDinoForActBiteInstanceLoop3
	    jmp NO_SpitterCode_RT
END_FindDinoForActBiteInstanceLoop3:

	;esi = dino instance
	;edx = canimal_info data struc for instance
	mov ecx,[edx+canimal_info.Count]
	mov eax,[animal_projectile_buffer]
	mov ebx,[ecx*4+eax]
	test ebx,ebx
	     jz NO_SpitterCode_RT	   ;is instance considered a spitter?
	;ebx = animproj_info data struc for instance

;------------------------------------------
;CHECK TIME VALUES AND LAUNCH PROBABILITY
;------------------------------------------

    ;make sure enough time has elapsed (SINCE LAST PROJECTILE LAUNCH)
	invoke GetTickCount
	mov edi,eax			       ;save tick
	sub eax,[ebx+animproj_info.LastTick]
	cmp eax,[ebx+animproj_info.MinInterval]
	    jb NO_SpitterCode_RT

    ;make sure enough time has elapsed (SINCE LAST PROBABILITY CHECK)
	mov eax,edi
	sub eax,[ebx+animproj_info.ProbabilityInterval_LastTick]
	cmp eax,[ebx+animproj_info.ProbabilityInterval]
	    jb NO_SpitterCode_RT
	mov [ebx+animproj_info.ProbabilityInterval_LastTick],edi   ;update launch probability tick

    ;random value check for launch probability
	stdcall GetRandomNumber,100
	cmp eax,[ebx+animproj_info.LaunchProbability]
	    ja NO_SpitterCode_RT

;------------------------------------------
;BEGIN LAUNCH CODE
;------------------------------------------

    ;get biting target instance
	mov eax,[esp+4] 		     ;CInfluence instance (eax)
	mov edi,[eax+CInfluence.lpSourceInstance]
    ;get dino's head boundary box instance
	mov esi,[esi+CAnimal.lpCBoundaryBoxHead]

    ;The following is not necessary (target can be of any type) /*
    ;;get biting target instance (CInfluence pointer parameter's source instance)
    ;     mov eax,[ebp+14h]                         ;CInfluence instance
    ;     mov edi,[eax+CInfluence.lpSourceInstance]
    ;     mov edx,[edi]
    ;     cmp edx,[CANIMALVTABLE]
    ;         jz SpitterCode_RT_BiteTargetFound
    ;     cmp edx,[CPLAYERPRIVVTABLE]
    ;         jz SpitterCode_RT_BiteTargetFound
    ;     cmp edx,[CBOUNDARYBOXVTABLE]                 ;accepts only these base object types
    ;         jnz NO_SpitterCode_RT
    ;         mov edi,[edi+CBoundaryBox.lpParentInstance]
    ;         mov edx,[edi]
    ;         cmp edx,[CANIMALVTABLE]
    ;             jz SpitterCode_RT_BiteTargetFound
    ;         cmp edx,[CPLAYERPRIVVTABLE]
    ;             jnz NO_SpitterCode_RT          ;if CBoundaryBox (most likely), ensure parent is Anne or dino and fetch
    ;     SpitterCode_RT_BiteTargetFound:
    ;*/

    ;edi = target bite instance
    ;esi = biting CAnimal instance's head boundary box
    ;ebx = animproj_info struct for biting CAnimal

    ;make sure there is enough horizontal-only distance between the two instances

	 fld [esi+CAnimal.Location.X]
	 fsub [edi+CInstance.Location.X]
	 fmul st0,st0
	 fld [esi+CAnimal.Location.Y]
	 fsub [edi+CInstance.Location.Y]
	 fmul st0,st0
	 faddp st1,st0
	 fst DWORD [ebp-4]
	 fcomp [ebx+animproj_info.MinDistanceHorizEXP2]
	 fstsw ax
	 test ah,1h			 ;(X-Y distance)^2 lower than (min distance horiz)^2?
	      jnz NO_SpitterCode_RT

    ;make sure there is enough 3d distance between the two instances
	 fld [esi+CAnimal.Location.Z]
	 fsub [edi+CInstance.Location.Z]
	 fmul st0,st0
	 fadd DWORD [ebp-4]
	 fst DWORD [ebp-8]
	 fcomp [ebx+animproj_info.MinDistanceEXP2]
	 fstsw ax
	 test ah,1h			 ;(X-Y-Z distance)^2 lower than (min distance)^2?
	      jnz NO_SpitterCode_RT

	;edi = target bite instance
	;esi = biting CAnimal instance's head boundary box
	;ebx = animproj_info struct for biting CAnimal

    ;make sure dino's head is facing towards target horizontally with view angle check
	;a = angle to get, b = limit angle, vectors are X-Y only (horizontal only)
	;                  -> assumed 0 <= b <= pi
	;-> limit angle is for each side of head, not total view angle
	;cos(a) = vector1.vector2 / (sizeof.vector1*sizeof.vector2)     ;. = dot product ; both vectors assumed non-zero
	;validity equation:      a <= b  (for any angle between 0 and 90)
	;                   cos(a) >= cos(b)
	;                   vector1.vector2 / (sizeof.vector1*sizeof.vector2) >= cos(b)
	;                   vector1.vector2 >= cos(b)*(sizeof.vector1*sizeof.vector2)      (valid since vector sizes will never change sign, always positive)
	;                   vector1.vector2 >= cos(b)*sizeof.vector1*sizeof.vector2
	;vector2 = vector between target & dino instances
	;vector1 = facing vector from dino head

	 lea edx,[ebp-32]
	 lea ecx,[esi+CBoundaryBox.OrientationQuat]
	 stdcall CONVERT_TO_FACING_PROC_010,edx,0	;get head's facing vector (vector1)

	 fld [edi+CInstance.Location.X]
	 fsub [esi+CBoundaryBox.Location.X]
	 fst DWORD [ebp-20]
	 fmul DWORD [ebp-32]
	 fld [edi+CInstance.Location.Y]
	 fsub [esi+CBoundaryBox.Location.Y]
	 fst DWORD [ebp-16]
	 fmul DWORD [ebp-28]
	 faddp st1,st0
	 fstp DWORD [ebp-36]

	;[ebp-32] = vector1
	;[ebp-20] = vector2
	;[ebp-36] = dot product

	 fld DWORD [ebp-32]
	 fmul st0,st0
	 fld DWORD [ebp-28]
	 fmul st0,st0
	 faddp st1,st0
	 fsqrt			  ;sizeof.vector1

	 fld DWORD [ebp-20]
	 fmul st0,st0
	 fld DWORD [ebp-16]
	 fmul st0,st0
	 faddp st1,st0
	 fsqrt			  ;sizeof.vector2

	 fmulp st1,st0		  ;sizeof.vector1*sizeof.vector2
	 fld [ebx+animproj_info.AnimalViewAngleCosine]
	 fmulp st1,st0		  ;sizeof.vector1*sizeof.vector2*cos(b)

	 fcomp DWORD [ebp-36]
	 fstsw ax
	 test ah,41h
	      jz NO_SpitterCode_RT   ;FINAL TEST FOR LAUNCH

  ;============================================================
  ;Update launch interval (since launch will surely happen at this point)
  ;============================================================

	 mov eax,[ebx+animproj_info.ProbabilityInterval_LastTick]
	 mov [ebx+animproj_info.LastTick],eax	;UPDATE PROJECTILE LAUNCH TICK (only if launch is going to happen)

  ;============================================================
  ;Do projectile launch
  ;============================================================
	 mov ecx,ebx
	 call GetNextAnimalProjectileInstance
	 mov edi,eax
	;3 DWORD at [ebp-32] = dino's head's facing UNIT vector (X,Y,Z)
	;esi = dino head CBoundaryBox instance
	;ebx = animproj_info struct for biting CAnimal
	;edi = Projectile instance

     ;calculate teleport location for projectile (store at stack_ext_buffer)
	 fld DWORD [ebp-32]
	 fmul [ebx+animproj_info.DistanceFromHead]
	 fadd [esi+CBoundaryBox.Location.X]
	 fstp DWORD [stack_ext_buffer+0]
	 fld DWORD [ebp-28]
	 fmul [ebx+animproj_info.DistanceFromHead]
	 fadd [esi+CBoundaryBox.Location.Y]
	 fstp DWORD [stack_ext_buffer+4]
	 fld DWORD [ebp-24]
	 fmul [ebx+animproj_info.DistanceFromHead]
	 fadd [esi+CBoundaryBox.Location.Z]
	 fstp DWORD [stack_ext_buffer+8]
      ;get orientation for projectile (from head)
	 mov eax,[esi+CBoundaryBox.OrientationQuat.W]
	 mov edx,[esi+CBoundaryBox.OrientationQuat.X]
	 mov DWORD [stack_ext_buffer+12],eax
	 mov DWORD [stack_ext_buffer+16],edx
	 mov eax,[esi+CBoundaryBox.OrientationQuat.Y]
	 mov edx,[esi+CBoundaryBox.OrientationQuat.Z]
	 mov DWORD [stack_ext_buffer+20],eax
	 mov DWORD [stack_ext_buffer+24],edx

      ;PROJECTILE LOCATION AT stack_ext_buffer (must calculate orientation
      ;that may change if auto-aim enabled before teleporting, and teleport
      ;must be done before velocity set)


      ;CALCULATE PROJECTILE SPEED AND DIRECTION
      ;(if needed, projectile's position at stack_ext_buffer)

	 mov ecx,AT110_EMULATED_OBJECT

	 fld DWORD [ebp-32]
	 fmul [ebx+animproj_info.ProjectileSpeed]
	 fstp [ecx+AT110Data.Velocity.X]
	 fld DWORD [ebp-28]
	 fmul [ebx+animproj_info.ProjectileSpeed]
	 fstp [ecx+AT110Data.Velocity.Y]
	 fld DWORD [ebp-24]
	 fmul [ebx+animproj_info.ProjectileSpeed]
	 fstp [ecx+AT110Data.Velocity.Z]

      ;CHECK FOR X-Y AUTOAIM
	 cmp [ebx+animproj_info.UseHorizontalAutoAim],FALSE
	     jz SpitterCode_RT_No_HorizAutoAim

	  ;MUST KEEP X-Y VECTOR MAGNITUDE SAME AS PREVIOUS
	  ;Ynew/Xnew = Ycurrent/Xcurrent
	  ;MAGNITUDE^2 = Yold^2 + Xold^2        ;Xold and Yold from  [ecx+CSetPhysicsAction.Velocity]
	  ;-> want new magnitude to match old but keep Y/X proportions from current values
	  ;   MAGNITUDE^2 = Ynew^2 + Xnew^2
	  ;   Ynew^2 + Xnew^2 = Yold^2 + Xold^2
	  ;          Ynew = (Ycurrent/Xcurrent)*Xnew
	  ;   ((Ycurrent/Xcurrent)*Xnew)^2 + Xnew^2 = Yold^2 + Xold^2
	  ;   Xnew^2*((Ycurrent/Xcurrent)^2+1) = Yold^2 + Xold^2
	  ;   Xnew = sqrt( (Yold^2 + Xold^2) / ((Ycurrent/Xcurrent)^2+1) )
	  ;        = sqrt( (Yold^2 + Xold^2) / ( Ycurrent^2/Xcurrent^2 + 1) )
	  ;        = sqrt( (Yold^2 + Xold^2) / ( Ycurrent^2/Xcurrent^2 + Xcurrent^2/Xcurrent^2) )
	  ;        = sqrt( (Yold^2 + Xold^2) / ( (Ycurrent^2 + Xcurrent^2)/Xcurrent^2 ) )
	  ;        = sqrt( (Yold^2 + Xold^2)*Xcurrent^2 / (Ycurrent^2 + Xcurrent^2) )
	  ;        = Xcurrent*sqrt(Yold^2 + Xold^2)/sqrt(Ycurrent^2 + Xcurrent^2)
	  ;   Xnew = Xcurrent*OldMagnitude/CurrentMagnitude
	  ;thus, Xnew/Xcurrent = Ynew/Ycurrent = OldMagnitude/CurrentMagnitude
	  ;   and
	  ;   Ynew = Ycurrent*OldMagnitude/CurrentMagnitude
	  ;notes: - Xold and Yold already take into account projectile speed
	  ;       - X-Y current values are simply assumed to be non-zero
	  ;         (which should be true if distances were set properly)

	    ;get biting target instance and get vector between projectile and target
	    ;(should be non-zero if all minimum distances and offset from head distance were set properly)
	     mov eax,[ebp+14h]			    ;CInfluence instance
	     mov edx,[eax+CInfluence.lpSourceInstance]
	     mov eax,(stack_ext_buffer+200)

	     fld [edx+CInstance.Location.X]
	     fsub DWORD [stack_ext_buffer+0]
	     fst DWORD [eax]
	     fmul st0,st0
	     fld [edx+CInstance.Location.Y]
	     fsub DWORD [stack_ext_buffer+4]
	     fst DWORD [eax+4]			    ;X-Ycurrent values at [eax]
	     fmul st0,st0
	     faddp st1,st0
	     fsqrt				    ;CurrentMagnitude

	     fld [ecx+AT110Data.Velocity.X]
	     fmul st0,st0
	     fld [ecx+AT110Data.Velocity.Y]
	     fmul st0,st0
	     faddp st1,st0
	     fsqrt				    ;OldMagnitude

	     fdivrp st1,st0			    ;OldMagnitude/CurrentMagnitude

	     fld DWORD [eax]
	     fmul st0,st1
	     fstp [ecx+AT110Data.Velocity.X]   ;Xnew = Xcurrent*OldMagnitude/CurrentMagnitude
	     fmul DWORD [eax+4]
	     fstp [ecx+AT110Data.Velocity.Y]   ;Ynew = Ycurrent*OldMagnitude/CurrentMagnitude

      SpitterCode_RT_No_HorizAutoAim:

      ;CHECK FOR Z AUTOAIM
      ;-> completely independant from X-Y autoaim, because will destroy
      ;   resulting vector's magnitude (ONLY adds to or subs from Z component for changes)

	 cmp [ebx+animproj_info.UseVerticalAutoAim],FALSE
	     jz SpitterCode_RT_No_VertAutoAim

	    ;get biting target instance
	     mov eax,[ebp+14h]			    ;CInfluence instance
	     mov edx,[eax+CInfluence.lpSourceInstance]

	    ;get time that will be taken for projectile to reach target with current
	    ;X-Y speed

	     fld [edx+CInstance.Location.X]
	     fsub DWORD [stack_ext_buffer+0]
	     fmul st0,st0
	     fld [edx+CInstance.Location.Y]
	     fsub DWORD [stack_ext_buffer+4]
	     fmul st0,st0
	     faddp st1,st0
	     fsqrt				    ;X-Y distance

	     fld [ecx+AT110Data.Velocity.X]
	     fmul st0,st0
	     fld [ecx+AT110Data.Velocity.Y]
	     fmul st0,st0
	     faddp st1,st0
	     fsqrt				    ;X-Y speed

	    ;zspeed = height / time
	    ;       = height / distance/speed
	    ;       = height*speed / distance

	     fld [edx+CInstance.Location.Z]
	     fsub DWORD [stack_ext_buffer+8]	    ;height
	     fadd [ebx+animproj_info.ProjectileZSpeedAdjust]	 ;HEIGHT Z SPEED ADJUST VALUE
	     fmulp st1,st0			    ;height * speed
	     fdivrp st1,st0			    ;height*speed / distance
	     fstp [ecx+AT110Data.Velocity.Z]
      SpitterCode_RT_No_VertAutoAim:

      ;SET PROJECTILE'S ORIENTATION from its intended velocity (must be
      ;done before velocity is set because includes teleport)
      ;VELOCITY AT [ecx+AT110Data.Velocity._]. Set orientation at 4 DWORD [stack_ext_buffer+12]
      ;This is only required if an Auto Aim setting is used, because otherwise
      ;the projectile will have the same orientation as the head

	 mov al,[ebx+animproj_info.UseVerticalAutoAim]
	 and al,[ebx+animproj_info.UseHorizontalAutoAim]
	    jz SpitterCode_RT_NoRecalculateProjectileOrientation
	    push ecx
	    mov edx,(stack_ext_buffer+12)
	    lea ecx,[ecx+AT110Data.Velocity]
	    call [PTRVectorToQuaternion]
	    pop ecx
	 SpitterCode_RT_NoRecalculateProjectileOrientation:

      ;TELEPORT PROJECTILE IN FRONT OF HEAD AND SET ORIENTATION (if no auto-aim,
      ;will be same as head orientation)

	 mov ecx,edi
	 mov eax,[edi]
	 push 0
	 push stack_ext_buffer
	 call [eax+ICInstance.Teleport]

      ;SET PROJECTILE CONSTANT VELOCITY VIA NEW ACTIONTYPE 110 AND FIXED SPEED CODE
	 mov ecx,AT110_EMULATED_OBJECT
	 mov eax,[edi+CInstance.InstanceNameID]
	 mov edx,[ebx+animproj_info.ProjectileExtinguishTime]
	 mov [ecx+AT110Data.InstanceNameID],eax
	 mov [ecx+AT110Data.Interval],edx
	 mov [ecx+AT110Data.RefCount],0
	 mov edx,[ecx]
	 mov [ecx+AT110Data.ForceBool],TRUE
	 call [edx+ICAction.MainProc]

NO_SpitterCode_RT:
pop ecx
pop eax
pop ebx
pop esi
pop edi
mov esp,ebp
pop ebp
ret

align 16
;============================================================
GetNextAnimalProjectileInstance:    ;ecx = animproj_info struct
;============================================================
;assumes at least one non-zero projectile instance in struct (always true due to
;context)
push ebx

       mov eax,[ecx+animproj_info.NextProjectileIndex]
       lea edx,[ecx+eax+animproj_info.ProjectileInstance]
       lea ebx,[ecx+animproj_info.ProjectileInstance+(4*8)]

       GetNextAnimalProjectileInstance_LOOP:
       add edx,4
       cmp edx,ebx
	   jb GetNextAnimalProjectileInstance_LOOP_Skip1
	   lea edx,[ecx+animproj_info.ProjectileInstance]
       GetNextAnimalProjectileInstance_LOOP_Skip1:
       mov eax,[edx]		;projectile instance
       test eax,eax
	    jz GetNextAnimalProjectileInstance_LOOP	;must find a projectile instance

       sub edx,ecx
       sub edx,animproj_info.ProjectileInstance
       mov [ecx+animproj_info.NextProjectileIndex],edx	;update projectile index for next function call

pop ebx
ret

