;=====================================================
;RT HUD DISPLAY
;=====================================================
;note: all BMPs are assumed or checked for 24-bit color

;=====================================================
DisplayHUD_RT:
;=====================================================
cmp [HUDon],0
    jz No_DisplayHUD_RT

cmp [HUD_ConvertPixelData_RunOnce],0
    jnz DisplayHUD_RT_HAS_BEEN_RUN_ONCE
	mov [HUD_ddbacksurfacepixeldesc.dwSize],sizeof.DDPIXELFORMAT
	mov [HUD_ddbacksurfacepixeldesc.dwFlags],DDPF_RGB

	mov eax,[BaseDDSurfaceADDR]
	mov edx,[eax]
	mov ecx,[edx+4Ch]		;get DD surface for screen

	push HUD_ddbacksurfacepixeldesc
	mov eax,[ecx]
	push ecx
	call [eax+DirectDrawSurface.GetPixelFormat]
	mov [HUD_ConvertPixelData_RunOnce],1

	mov [HUD_ddbacksurfacergbtype],SCREEN_16BITRGB_FORMAT_565
	cmp [HUD_ddbacksurfacepixeldesc.dwGBitMask],000007E0h
	    jz DisplayHUD_RT_HAS_BEEN_RUN_ONCE_Not555
	mov [HUD_ddbacksurfacergbtype],SCREEN_16BITRGB_FORMAT_555
	DisplayHUD_RT_HAS_BEEN_RUN_ONCE_Not555:

	mov esi,HUD_ImagesPointers
	DisplayHUD_RT_HAS_BEEN_RUN_ONCE_ConvertLoop:
	cmp [esi+HUDImgInfo.lpBmpData],0
	    jz DisplayHUD_RT_HAS_BEEN_RUN_ONCE_ConvertLoop_SKIPIMAGE

	mov eax,[esi+HUDImgInfo.Width]
	mov ecx,[esi+HUDImgInfo.Height]
	mul ecx
	shl eax,1	;eax = base size for bit array (without scan-line DWORD-boundary alignment)
       ;if Width was an even number, no padding 0's needed
	mov ecx,[esi+HUDImgInfo.Width]
	test ecx,1
	     jz DisplayHUD_RT_HAS_BEEN_RUN_ONCE_NoPadding
	shl ecx,1
	add eax,ecx
	DisplayHUD_RT_HAS_BEEN_RUN_ONCE_NoPadding:
	invoke VirtualAlloc,0,eax,MEM_COMMIT+MEM_RESERVE,PAGE_READWRITE
	mov edi,eax

	stdcall Convert24BitImageTo16Bit,[esi+HUDImgInfo.lpBmpData],edi,[esi+HUDImgInfo.Width],\
					 [esi+HUDImgInfo.Height],[HUD_ddbacksurfacergbtype]
	push eax
	VIRTUALRELEASE [esi+HUDImgInfo.lpBmpData],[esi+HUDImgInfo.Size]
	pop eax
	mov [esi+HUDImgInfo.lpBmpData],edi
	mov [esi+HUDImgInfo.Size],eax

	DisplayHUD_RT_HAS_BEEN_RUN_ONCE_ConvertLoop_SKIPIMAGE:
	add esi,sizeof.HUDImgInfo
	cmp esi,HUD_ImagesPointers_END
	    jb DisplayHUD_RT_HAS_BEEN_RUN_ONCE_ConvertLoop

DisplayHUD_RT_HAS_BEEN_RUN_ONCE:

;position and display player health background + digits
	mov eax,[PLAYER_OBJ_INVUL_ADDR]
	mov esi,HUD_PlayerHealthBG
	mov ecx,[eax]
	mov ebx,HUD_PlayerHealthBG_Info
	sub esp,8
	fld DWORD [ecx+50h]
	fistp DWORD [esp]
	fld DWORD [ecx+54h]
	fistp DWORD [esp+4]
	call DisplayHUD_RT_CurrentBG

;position and display primary gun ammo + digits
	mov ecx,GETWEAPON_PRIMARY
	call GetHeldWeaponInstance
	xor edx,edx
	test eax,eax
	push edx
	push edx
	     jz DisplayHUD_RT_NoPrimary
	mov ecx,[eax+6Ch]
	mov edx,[eax+68h]
	mov [esp],ecx
	mov [esp+4],edx
	DisplayHUD_RT_NoPrimary:
	mov esi,HUD_PrimaryAmmoBG
	mov ebx,HUD_PrimaryAmmoBG_Info
	call DisplayHUD_RT_CurrentBG

;position and display secondary gun ammo + digits
	mov ecx,GETWEAPON_SECONDARY
	call GetHeldWeaponInstance
	xor edx,edx
	test eax,eax
	push edx
	push edx
	     jz DisplayHUD_RT_NoSecondary
	mov ecx,[eax+6Ch]
	mov edx,[eax+68h]
	mov [esp],ecx
	mov [esp+4],edx
	DisplayHUD_RT_NoSecondary:
	mov esi,HUD_SecondaryAmmoBG
	mov ebx,HUD_SecondaryAmmoBG_Info
	call DisplayHUD_RT_CurrentBG

;exit

No_DisplayHUD_RT:
ret

;=====================================================
DisplayHUD_RT_CurrentBG:    ;edi=dest. DC, esi = HUDImgInfo struct, ebx = HUD info struct, param1 = value to print, param2 = max value
;=====================================================
push ebp

	cmp [esi+HUDImgInfo.lpBmpData],0
	    jz DisplayHUD_RT_CurrentBG_Exit   ;if background is unavailable, display nothing

	mov eax,[BaseDDSurfaceADDR]
	mov ebp,[eax]

	xor eax,eax
	mov edx,1.000000
	mov [HUD_BGPosX],eax
	mov [HUD_BGPosY],eax		      ;default pos = 0

    ;calculate temporary resizing float value

	mov [HUD_ResDivDefaultResX],edx
	mov [HUD_ResDivDefaultResY],edx

	cmp [ebx+HUDBGInfo.UseResizing],0
	    jz DisplayHUD_RT_CurrentBG_NoResize
	cmp [ebx+HUDBGInfo.ResizeResX],0
	    jle DisplayHUD_RT_CurrentBG_NoResize
	cmp [ebx+HUDBGInfo.ResizeResY],0
	    jle DisplayHUD_RT_CurrentBG_NoResize
	fild DWORD [ebp+8]
	fidiv [ebx+HUDBGInfo.ResizeResX]
	fstp [HUD_ResDivDefaultResX]
	fild DWORD [ebp+12]
	fidiv [ebx+HUDBGInfo.ResizeResY]
	fstp [HUD_ResDivDefaultResY]
	DisplayHUD_RT_CurrentBG_NoResize:

	fild [esi+HUDImgInfo.Width]
	fmul [HUD_ResDivDefaultResX]
	fistp [HUD_BGWidth]

	fild [esi+HUDImgInfo.Height]
	fmul [HUD_ResDivDefaultResY]
	fistp [HUD_BGHeight]

;perform x alignment

	cmp [ebx+HUDBGInfo.AlignmentX],HUD_ALIGNX_LEFT
	    jz DisplayHUD_RT_CurrentBG_XAlignDone
	cmp [ebx+HUDBGInfo.AlignmentX],HUD_ALIGNX_CENTER
	    jnz DisplayHUD_RT_CurrentBG_Skip1
	    mov eax,[ebp+08h]		;x resolution
	    mov edx,[HUD_BGWidth]
	    shr eax,1			;halfway
	    shr edx,1
	    sub eax,edx
	    mov [HUD_BGPosX],eax
	    jmp DisplayHUD_RT_CurrentBG_XAlignDone
	DisplayHUD_RT_CurrentBG_Skip1:
	cmp [ebx+HUDBGInfo.AlignmentX],HUD_ALIGNX_RIGHT
	    jnz DisplayHUD_RT_CurrentBG_XAlignDone
	    mov eax,[ebp+08h]		;x resolution
	    sub eax,[HUD_BGWidth]
	    mov [HUD_BGPosX],eax
	DisplayHUD_RT_CurrentBG_XAlignDone:

;perform y alignment
	cmp [ebx+HUDBGInfo.AlignmentY],HUD_ALIGNY_TOP
	    jz DisplayHUD_RT_CurrentBG_YAlignDone
	cmp [ebx+HUDBGInfo.AlignmentY],HUD_ALIGNY_CENTER
	    jnz DisplayHUD_RT_CurrentBG_Skip2
	    mov eax,[ebp+0Ch]		;y resolution
	    mov edx,[HUD_BGHeight]
	    shr eax,1			;halfway
	    shr edx,1
	    sub eax,edx
	    mov [HUD_BGPosY],eax
	    jmp DisplayHUD_RT_CurrentBG_YAlignDone
	DisplayHUD_RT_CurrentBG_Skip2:
	cmp [ebx+HUDBGInfo.AlignmentY],HUD_ALIGNY_BOTTOM
	    jnz DisplayHUD_RT_CurrentBG_YAlignDone
	    mov eax,[ebp+0Ch]		;x resolution
	    sub eax,[HUD_BGHeight]
	    mov [HUD_BGPosY],eax
	DisplayHUD_RT_CurrentBG_YAlignDone:

;perform displacements (with resizing, if necessary)

	fild [ebx+HUDBGInfo.DisplacementX]
	fmul [HUD_ResDivDefaultResX]
	fiadd [HUD_BGPosX]
	fistp [HUD_BGPosX]

	fild [ebx+HUDBGInfo.DisplacementY]
	fmul [HUD_ResDivDefaultResY]
	fiadd [HUD_BGPosY]
	fistp [HUD_BGPosY]

	stdcall DirectXBitmapBltWithTransparency16,[HUD_BGPosX],[HUD_BGPosY],\
		[esi+HUDImgInfo.Width],[esi+HUDImgInfo.Height],\
		[esi+HUDImgInfo.lpBmpData],DDBLT_KEYSRC,[esi+HUDImgInfo.Size],\
		[HUD_ddbacksurfacergbtype],[HUD_BGWidth],[HUD_BGHeight]

;get digit indexes for first value
	mov eax,[esp+8]
	LIMITVALUE eax,0,999

	cdq
	mov ecx,10
	div ecx
	mov [HUD_NumberIndexPos1],edx

	cdq
	div ecx
	mov [HUD_NumberIndexPos10],edx

	cdq
	div ecx
	mov [HUD_NumberIndexPos100],edx

;get digit indexes for second value (if enabled)

cmp [ebx+HUDBGInfo.UseDigits2],0
    jz DisplayHUD_RT_CurrentBG_NoDigits2_B
	mov eax,[esp+12]
	LIMITVALUE eax,0,999

	cdq
	mov ecx,10
	div ecx
	mov [HUD_Number2IndexPos1],edx

	cdq
	div ecx
	mov [HUD_Number2IndexPos10],edx

	cdq
	div ecx
	mov [HUD_Number2IndexPos100],edx
DisplayHUD_RT_CurrentBG_NoDigits2_B:

;if padding is not enabled, use dummy indexes where necessary
	cmp [ebx+HUDBGInfo.UseDigitPadding],FALSE
	    jz DisplayHUD_RT_CurrentBG_NoPadding

	mov eax,[esp+8]
	cmp eax,100
	    jnb DisplayHUD_RT_CurrentBG_PaddingDone1
	    mov [HUD_NumberIndexPos100],-1
	cmp eax,10
	    jnb DisplayHUD_RT_CurrentBG_PaddingDone1
	    mov [HUD_NumberIndexPos10],-1
	DisplayHUD_RT_CurrentBG_PaddingDone1:

cmp [ebx+HUDBGInfo.UseDigits2],0	     ;pad second value (if enabled)
    jz DisplayHUD_RT_CurrentBG_NoDigits2_C
	mov eax,[esp+12]
	cmp eax,100
	    jnb DisplayHUD_RT_CurrentBG_PaddingDone2
	    mov [HUD_Number2IndexPos100],-1
	cmp eax,10
	    jnb DisplayHUD_RT_CurrentBG_PaddingDone2
	    mov [HUD_Number2IndexPos10],-1
	DisplayHUD_RT_CurrentBG_PaddingDone2:
DisplayHUD_RT_CurrentBG_NoDigits2_C:

	DisplayHUD_RT_CurrentBG_NoPadding:

;draw first number

	fild [ebx+HUDBGInfo.DigitsOffsetX]
	fmul [HUD_ResDivDefaultResX]
	fiadd [HUD_BGPosX]
	fistp [HUD_NextDigitPosX]
	fild [ebx+HUDBGInfo.DigitsOffsetY]
	fmul [HUD_ResDivDefaultResY]
	fiadd [HUD_BGPosY]
	fistp [HUD_NextDigitPosY]

	stdcall DisplayHUD_RT_CurrentBG_PrintNumber,HUD_NumberIndexPos100

;draw second number (if enabled)
	cmp [ebx+HUDBGInfo.UseDigits2],0
	    jz DisplayHUD_RT_CurrentBG_NoDigits2_A
	fild [ebx+HUDBGInfo.Digits2OffsetX]
	fmul [HUD_ResDivDefaultResX]
	fiadd [HUD_BGPosX]
	fistp [HUD_NextDigitPosX]
	fild [ebx+HUDBGInfo.Digits2OffsetY]
	fmul [HUD_ResDivDefaultResY]
	fiadd [HUD_BGPosY]
	fistp [HUD_NextDigitPosY]
	stdcall DisplayHUD_RT_CurrentBG_PrintNumber,HUD_Number2IndexPos100
	DisplayHUD_RT_CurrentBG_NoDigits2_A:

DisplayHUD_RT_CurrentBG_Exit:

pop ebp
ret 8


;=====================================================
DisplayHUD_RT_CurrentBG_PrintNumber:   ;param1 = pointer to struct w/ 3 digits
;=====================================================
;requires HUD_ResDivDefaultResX and Y set before call
;edi = DC
;updates HUD_NextDigitPosX
push ebp
mov ebp,esp
sub esp,4
push esi
push ebx

	mov DWORD [ebp-4],3
	mov esi,[ebp+8]

	DisplayHUD_RT_CurrentBG_PrintNumber_LOOP:
	mov [HUD_LastDigitWidth],0

	mov eax,[esi]			;digit index
	cmp eax,-1
	    jnz DisplayHUD_RT_CurrentBG_PrintNumber_LOOP_NotNeg1
	    xor eax,eax 		     ;will get width of 0 digit even if not printed
	DisplayHUD_RT_CurrentBG_PrintNumber_LOOP_NotNeg1:
	shl eax,4			;HARDCODED !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	lea ebx,[HUD_Digits+eax]	;ebx = HUDImgInfo struc for bitmap for next digit

	cmp [ebx+HUDImgInfo.lpBmpData],0    ;if no bitmap for digit, skip and leave no space (undetermined width)
	     jz DisplayHUD_RT_CurrentBG_PrintNumber_LOOP_SKIPNUMBER

	fild [ebx+HUDImgInfo.Width]
	fmul [HUD_ResDivDefaultResX]
	fistp [HUD_LastDigitWidth]
	fild [ebx+HUDImgInfo.Height]
	fmul [HUD_ResDivDefaultResY]
	fistp [HUD_LastDigitHeight]

	cmp DWORD [esi],-1		;did we have a non-printing char? if so, do not print, but must add width to position for next char (leave empty space)
	    jz DisplayHUD_RT_CurrentBG_PrintNumber_LOOP_SKIPNUMBER

	stdcall DirectXBitmapBltWithTransparency16,[HUD_NextDigitPosX],[HUD_NextDigitPosY],\
		[ebx+HUDImgInfo.Width],[ebx+HUDImgInfo.Height],[ebx+HUDImgInfo.lpBmpData],\
		DDBLT_KEYSRC,[ebx+HUDImgInfo.Size],[HUD_ddbacksurfacergbtype],\
		[HUD_LastDigitWidth],[HUD_LastDigitHeight]

	DisplayHUD_RT_CurrentBG_PrintNumber_LOOP_SKIPNUMBER:

	mov eax,[HUD_LastDigitWidth]
	add [HUD_NextDigitPosX],eax

	add esi,4
	dec DWORD [ebp-4]
	    jnz DisplayHUD_RT_CurrentBG_PrintNumber_LOOP

pop ebx
pop esi
mov esp,ebp
pop ebp
ret 4


;=====================================================
InitHUD:
;=====================================================
;returns eax = 0 if success
push edi
push esi
push ebx

	mov ecx,[MapsPathSize]
	mov esi,MapsDirBuffer
	mov edi,HUD_INIPath
	rep movsb
	mov DWORD [edi],'HUD\'
	mov esi,HUD_ImagesLocationININame
	add edi,4
	call TransferString

	mov ecx,[MapsPathSize]
	mov esi,MapsDirBuffer
	mov edi,HUD_CurrentBMPPath
	rep movsb
	mov DWORD [edi],'HUD\'
	add edi,4
	mov [HUD_CurrentBMPPathEnd],edi
	sub edi,HUD_CurrentBMPPath
	mov [HUD_CurrentBMPPathSize],edi

	xor esi,esi

	InitHUD_LOOP:

	mov ecx,MAX_PATH
	sub ecx,[HUD_CurrentBMPPathSize]
	invoke GetPrivateProfileString,HUD_INISectName_Locations,[esi+HUD_ImagesININamesPointers],\
	       HUD_INIEntryNamenone,[HUD_CurrentBMPPathEnd],ecx,HUD_INIPath

	mov ecx,[HUD_CurrentBMPPathEnd]
	xor eax,eax
	cmp DWORD [ecx],'none'
	    jz InitHUD_LOOP_INVALID

     ;get header and basic info
	stdcall LoadRGBBitmapFromFile,HUD_CurrentBMPPath,tempBMPinfo,24

	InitHUD_LOOP_INVALID:

    ;HARDCODED!!!!!!!
	test eax,eax
	     jz InitHUD_LOOP_NODATA1
	mov [esi*4+HUD_ImagesPointers+HUDImgInfo.lpBmpData],eax  ;will be null if error
	mov eax,[tempBMPinfo.biWidth]
	mov ecx,[tempBMPinfo.biHeight]
	mov edx,[tempBMPinfo.biSizeImage]
	mov [esi*4+HUD_ImagesPointers+HUDImgInfo.Width],eax
	mov [esi*4+HUD_ImagesPointers+HUDImgInfo.Height],ecx
	mov [esi*4+HUD_ImagesPointers+HUDImgInfo.Size],edx
	InitHUD_LOOP_NODATA1:

	add esi,4
	cmp esi,(HUD_ImagesININamesPointers_END-HUD_ImagesININamesPointers)
	    jb InitHUD_LOOP

	stdcall GetHUDBGImageInfo,HUD_INISectName_Health,HUD_PlayerHealthBG_Info,HUD_INIPath
	stdcall GetHUDBGImageInfo,HUD_INISectName_Ammo1,HUD_PrimaryAmmoBG_Info,HUD_INIPath
	stdcall GetHUDBGImageInfo,HUD_INISectName_Ammo2,HUD_SecondaryAmmoBG_Info,HUD_INIPath

	xor eax,eax
pop ebx
pop esi
pop edi
ret

;=====================================================
GetHUDBGImageInfo:    ;param1=section name, param2 = destination struct, param3 = INI filename
;=====================================================
push ebp
mov ebp,esp
push ebx
push edi

	xor ebx,ebx
	mov edi,[ebp+12]
	GetHUDBGImageInfo_LOOP:

	invoke GetPrivateProfileInt,[ebp+8],[ebx+HUD_INIEntryBGInfoTable],0,[ebp+16]
	mov [edi],eax

	add edi,4
	add ebx,4
	cmp ebx,sizeof.HUDBGInfo
	    jb GetHUDBGImageInfo_LOOP

pop edi
pop ebx
mov esp,ebp
pop ebp
ret 12

;=====================================================
ReleaseHUD:
;=====================================================

push esi

	mov esi,HUD_ImagesPointers
	ReleaseHUD_LOOP:
	mov eax,[esi+HUDImgInfo.lpBmpData]
	VIRTUALRELEASE eax,[esi+HUDImgInfo.Size]
	add esi,sizeof.HUDImgInfo
	cmp esi,HUD_ImagesPointers_END
	    jb ReleaseHUD_LOOP

pop esi

ret








