;compile using FASM (see "SOURCE_README.txt" for last version used)

RECCOMPRESS_VERSION	    equ     '1.4'
VALLOCFRAMECOUNT	    equ     4	      ;determines size of frame buffer
					      ;(number of frames it contains)

format PE GUI 4.0
entry START
stack 20000h		;required: GetOpenFileName may crash under certain circumstances if less
			;(witnessed with WinRAR menu options, when right-clicking on an EXE file)

include '%fasminc%\WIN32A.INC'	;must have FASM environment variable set properly for this
include '..\Data\constants.inc'
include '..\Data\strucs.inc'
include '..\Data\macros.inc'

;=================================================================
section '.code' code readable executable
;=================================================================
;edi = messagebox text
START:
push ebp
push ebx
push esi
push edi

	invoke GetModuleHandle,0
	mov edi,ininame_buffer
	invoke GetModuleFileName,eax,edi,512

	FINDSTRINGEND edi

	FindFilePart_A:
	cmp BYTE [edi-1],'\'
	    jz FindFilePart_END
	dec edi
	jmp FindFilePart_A
	FindFilePart_END:

	mov DWORD [edi],'ATXc'
	mov DWORD [edi+4],'onfi'
	mov DWORD [edi+8],'g.in'
	mov WORD [edi+12],0069h

	invoke GetPrivateProfileInt,section_videorecording,key_invertatcomp,0,ininame_buffer
	test eax,eax
	    jz NoChangeInvertFlag_A
	or [PreComp_XORMASK],INVERT_UP_DOWN_IMAGES
	NoChangeInvertFlag_A:

	invoke InitCommonControls
	invoke AVIFileInit

;FILL IN STANDARD STRUCTURES
	mov [textrect1.top],5		;"Please select..." text
	mov [textrect1.left],5
	mov [textrect1.bottom],50
	mov [textrect1.right],370

	mov [textrect2.top],30		;encoding info text
	mov [textrect2.left],5
	mov [textrect2.bottom],85
	mov [textrect2.right],370

	mov [textrect3.top],155 	;file info text
	mov [textrect3.left],5
	mov [textrect3.bottom],337
	mov [textrect3.right],370

	mov [OFN_info.lStructSize],sizeof.OPENFILENAME
	mov [OFN_info.lpstrFilter],filter_strings
	mov [OFN_info.lpstrFile],source_file
	mov [OFN_info.nMaxFile],512
	mov [OFN_info.lpstrDefExt],default_extension
	mov [OFN_info.lpstrTitle],open_file_caption
	mov [OFN_info.Flags],OFN_FILEMUSTEXIST+OFN_LONGNAMES+OFN_PATHMUSTEXIST+OFN_EXPLORER+OFN_HIDEREADONLY
	mov [OFN_info.lpstrFileTitle],source_file_nameonly
	mov [OFN_info.nMaxFileTitle],256

;CREATE MAIN WINDOW CLASS AND WINDOW
	mov [wc.cbSize],sizeof.WNDCLASSEX
	mov [wc.style],CS_HREDRAW+CS_VREDRAW
	mov [wc.lpfnWndProc],WndProc
	invoke GetModuleHandle,0
	mov [hInstance],eax
	mov [wc.hInstance],eax
	invoke LoadIcon,0,IDI_APPLICATION
	mov [wc.hIcon],eax
	mov [wc.hIconSm],eax
	invoke LoadCursor,0,IDC_ARROW
	mov [wc.hCursor],eax
	mov [wc.lpszClassName],wndclassname
	mov [wc.hbrBackground],COLOR_WINDOW	   ;COLOR_BTNFACE+1         ;
	invoke RegisterClassEx,wc

	invoke CreateWindowEx,0,wndclassname,wndname,\
			WS_OVERLAPPED+WS_CAPTION+WS_SYSMENU+WS_MINIMIZEBOX,\
			CW_USEDEFAULT,CW_USEDEFAULT,385,365,0,0,[hInstance],0
	mov [hwnd],eax

	invoke ShowWindow,[hwnd],SW_SHOWNORMAL
	invoke UpdateWindow,[hwnd]

;MAIN MESSAGE LOOP
	MsgLoopMain:
	invoke PeekMessage,msgbuf,0,0,0,PM_REMOVE
	test eax,eax
	     jz NoMessagesMsgLoop
	cmp [msgbuf.message],WM_QUIT
	    jz ExitMsgLoop1
	invoke TranslateMessage,msgbuf
	invoke DispatchMessage,msgbuf
	NoMessagesMsgLoop:

	cmp [is_encoding],TRUE
	    jnz MsgLoopMain

	mov eax,[dibfileheader.DiffFrameCount]
	cmp [DiffFrameCount_current],eax
	    jnb EndVideoCompression

;READ DIB DATA FROM REC FILE TO BUFFER IF NEEDED

	mov eax,[valloc_end_ptr]
	cmp [valloc_index_ptr],eax
	    jb NoReadDIBDataFromRECFile

	mov [bytesread_temp],0
	invoke ReadFile,[source_file_handle],[dibtempbufferaddr],[valloc_bufsize],\
			bytesread_temp,0
	       ;test eax,eax     ;(do not report errors; may reach EOF)
	       ;mov [lastcompiniterror],errorI
	       ;    jz CompressInitErrorMsgLoop
	mov eax,[dibtempbufferaddr]
	mov [valloc_index_ptr],eax

	NoReadDIBDataFromRECFile:

;check for 16-bit 5-6-5 pixel format and convert frame to 5-5-5 format if necessary
	mov eax,[dibfileheader.SaveFlags]
	cmp eax,'ECDF'
	    jz NoSpecialFormatting_A
	test eax,PIXEL_FORMAT_16_5_6_5
	    jz PixelFormatAlready_STD
	     push esi
	     mov esi,[valloc_index_ptr]
	     mov ecx,[vrdef_bufsize]
	     shr ecx,3		;/2 (number of qwords)

	     NewSaveMethod16BPPConvertLoop:
	     movq mm0,[esi]
	     movq mm1,mm0
	     psrlw mm0,1			;shift Red-Green values from 5-6 to 5-5 (4 pixels at a time)
	     pand mm1,[Blue16_MMX_Mask]
	     pand mm0,[Blue16_MMX_Mask_Erase]
	     por mm0,mm1
	     movq [esi],mm0
	     add esi,8
	     loop NewSaveMethod16BPPConvertLoop

	     pop esi
	     emms
	PixelFormatAlready_STD:

	test [dibfileheader.SaveFlags],INVERT_UP_DOWN_IMAGES	;16-bit only
	     jz NoMirrorBitmapsUpDown_A
	     push esi
	     push ebx
	     push edi
	     push ebp
	     mov esi,[valloc_index_ptr]
	     mov ebx,[dibfileheader.BitmapData.biWidth]
	     mov ecx,[dibfileheader.BitmapData.biHeight]
	     lea eax,[ebx*2]				   ;pitch
	     sub ecx,1
	     mov ebp,eax
	     mov edi,esi
	     shl ebp,1
	     mul ecx
	     shr ebx,2					   ;width*2/8 = width/4 = # qwords in scanline
	     add edi,eax				   ;edi points to last scanline

	     mov edx,[dibfileheader.BitmapData.biHeight]
	     shr edx,1

	     InvertImageHeightLoop_A:
	     mov ecx,ebx
	     InvertImageWidthLoop_A:
	     movq mm0,[esi]
	     movq mm1,[edi]
	     movq [esi],mm1
	     movq [edi],mm0
	     add esi,8
	     add edi,8
	     loop InvertImageWidthLoop_A
	     sub edi,ebp
	     sub edx,1
		 jnz InvertImageHeightLoop_A

	     pop ebp
	     pop edi
	     pop ebx
	     pop esi
	     emms
	NoMirrorBitmapsUpDown_A:

	NoSpecialFormatting_A:

;WRITE CURRENT FRAME TO COMPRESSED AVI STREAM (w/repeat count)
	AVIStreamWrite_LOOP:
	invoke AVIStreamWrite,[avistream_handle],[TrueFrameCount_current],1,\
			[valloc_index_ptr],[vrdef_bufsize],0,0,0
	       test eax,eax
	       mov [lastcompiniterror],errorH
		    jnz CompressInitErrorMsgLoop
	       inc [TrueFrameCount_current]
	       mov ecx,[framerepeatcount_BUF]
	       add ecx,[DiffFrameCount_current]
	       mov al,[ecx]		     ;check number of times to repeat frame
	       dec al
	       cmp al,0FFh
	       mov [ecx],al
		   jnz AVIStreamWrite_LOOP

;calculate progress bar position
	mov eax,[TrueFrameCount_current]
	mov [estateparam2],eax
	mov ecx,100
	mul ecx
	mov ecx,[dibfileheader.TrueFrameCount]
	div ecx 			       ;(currentcount*100)/(totalcount)
	invoke SendMessage,[progbarhandle],PBM_SETPOS,eax,0

	inc [DiffFrameCount_current]
	mov eax,[vrdef_bufsize]
	add [valloc_index_ptr],eax

;update encoding info
	invoke InvalidateRect,[hwnd],textrect2,TRUE    ;required for WM_PAINT to be sent via UpdateWindow
	invoke UpdateWindow,[hwnd]
	jmp MsgLoopMain

	ExitMsgLoop1:


	invoke AVIFileExit
pop edi
pop esi
pop ebx
pop ebp
invoke ExitProcess,[msgbuf.wParam]

;=================================================================
WndProc:
;=================================================================
	mov edx,[esp+8]
	cmp edx,WM_DESTROY
	    jz ExitProgramWndProc
	cmp edx,WM_CREATE
	    jz CreateAllWndProc
	cmp edx,WM_PAINT
	    jz PaintMessageWndProc
	cmp edx,WM_COMMAND
	    jz ButtonClickCheckWndProc
	cmp edx,WM_CHAR
	    jz KeyCommandWndProc

MessageNotProcessed:
invoke DefWindowProc,[esp+16],edx,[esp+16],[esp+16]
ret 16

;=================================================================
ExitProgramWndProc:
;=================================================================
	invoke PostQuitMessage,0
	cmp [is_encoding],FALSE
	    jz NoCancelEncodingOnExit
	call ReleaseAllBuffers
	NoCancelEncodingOnExit:
	xor eax,eax
	ret 16

;=================================================================
CreateAllWndProc:
;=================================================================

;create exit button
	invoke CreateWindowEx,0,btclassname,exitbttext,WS_CHILD+WS_VISIBLE+BS_DEFPUSHBUTTON,\
				190,122,180,25,[esp+4+12],0,[hInstance],0
	mov [btexithandle],eax	      ;[esp+4+12]= hwnd passed to WndProc

;create file select/cancel button
	invoke CreateWindowEx,0,btclassname,openbttext1,WS_CHILD+WS_VISIBLE+BS_DEFPUSHBUTTON,\
				5,122,180,25,[esp+4+12],0,[hInstance],0
	mov [btopenhandle],eax

;create progress bar
	invoke CreateWindowEx,0,pbclassname,0,WS_CHILD+WS_VISIBLE,\
				5,90,360,15,[esp+4+12],0,[hInstance],0
	mov [progbarhandle],eax

	invoke SendMessage,[progbarhandle],PBM_SETRANGE,0,010000h*100
	invoke SendMessage,[progbarhandle],PBM_SETSTEP,1,0
	xor eax,eax
	ret 16

;=================================================================
PaintMessageWndProc:
;=================================================================
	push esi
	push ebp
	push ebx
	push edi
	mov ebp,esp
	sub esp,400
	invoke BeginPaint,[hwnd],psbuf
	mov edi,eax

	invoke SetTextColor,edi,0
	invoke SetBkMode,edi,TRANSPARENT

;draw "Please select..." text
	mov edx,nofiletext
	mov ecx,edx
	FINDSTRINGEND ecx

	sub ecx,edx
	invoke DrawText,edi,edx,ecx,textrect1,DT_LEFT+DT_NOCLIP+DT_WORDBREAK

;draw encoding progress text
	lea ebx,[ebp-250]
	invoke wsprintf,ebx,[encodestate_ptr],[estateparam1],[estateparam2],[estateparam3]
	add esp,5*4
	invoke DrawText,edi,ebx,eax,textrect2,DT_LEFT+DT_NOCLIP+DT_WORDBREAK

;set up data for file info text
	cmp BYTE [source_file_nameonly],0
	    jz NoDisplayFileInfo1
	lea ebx,[ebp-400]
	mov eax,[dibfileheader.TrueFrameCount]
	cdq
	mov ecx,[dibfileheader.Framerate]
	test ecx,ecx
	     jz NoDivZeroFPS_1
	div ecx
	mov ecx,eax
	NoDivZeroFPS_1:
	mov esi,ecx			  ;length (# frames / frames per second)

	mov eax,[vrdef_bufsize]
	mov ecx,[dibfileheader.TrueFrameCount]
	mul ecx

	mov edx,[dibfileheader.TrueFrameCount]
	sub edx,[dibfileheader.DiffFrameCount]
	xor ecx,ecx
	mov cx,[dibfileheader.BitmapData.biBitCount]

	push STRING_N_A
	push STRING_N_A
	cmp [dibfileheader.SaveFlags],'ECDF'
	    jz NoNewSaveFlagsInfo

	mov [esp],DWORD STRING_NO
	test [dibfileheader.SaveFlags],PIXEL_FORMAT_16_5_6_5
	     jz ImageNot565_B
	     mov [esp],DWORD STRING_YES
	ImageNot565_B:

	mov [esp+4],DWORD STRING_NO
	test [dibfileheader.SaveFlags],INVERT_UP_DOWN_IMAGES
	     jz ImageNotInverted_B
	     mov [esp+4],DWORD STRING_YES
	ImageNotInverted_B:

	NoNewSaveFlagsInfo:

	invoke wsprintf,ebx,fileinfostring,[dibfileheader.BitmapData.biWidth],\
		   [dibfileheader.BitmapData.biHeight],ecx,\
		   [dibfileheader.Framerate],[dibfileheader.TrueFrameCount],edx,\
		   [dibfileheader.rv_rt_error_count],esi,eax
	add esp,13*4

;draw file info text
	invoke DrawText,edi,ebx,eax,textrect3,DT_LEFT+DT_NOCLIP
	NoDisplayFileInfo1:

	invoke EndPaint,[hwnd],psbuf

	mov esp,ebp
	pop edi
	pop ebx
	pop ebp
	pop esi
	xor eax,eax
	ret 16

;=================================================================
KeyCommandWndProc:
;=================================================================
	mov al,[esp+12]
	CHAR_TOLOWERCASE al
	cmp al,'s'
	    jz OpenFileButtonPress
	cmp al,'c'
	    jz OpenFileButtonPress
	cmp al,'e'
	    jz ExitButtonPress
	jmp MessageNotProcessed

;=================================================================
ButtonClickCheckWndProc:
;=================================================================
	mov eax,[esp+16]
	test eax,eax
	    jz MessageNotProcessed
	cmp WORD [esp+14],BN_CLICKED
	    jnz MessageNotProcessed
	cmp eax,[btexithandle]
	    jz ExitButtonPress
	cmp eax,[btopenhandle]
	    jz OpenFileButtonPress
	jmp MessageNotProcessed

ExitButtonPress:
	invoke SendMessage,[hwnd],WM_DESTROY,0,0
	xor eax,eax
	ret 16

OpenFileButtonPress:
	invoke SendMessage,[progbarhandle],PBM_SETPOS,0,0
	cmp [is_encoding],TRUE
	mov [lastcompiniterror],errorG
	    jz CompressInitError

;=================================================================
GetFileAndBeginEncoding:
;=================================================================
	invoke GetOpenFileName,OFN_info
	test eax,eax
	mov [lastcompiniterror],errorB
	    jz CompressInitError

;OPEN SOURCE FILE AND RETRIEVE HEADER
	invoke CreateFile,source_file,GENERIC_READ,0,0,OPEN_EXISTING,\
			FILE_ATTRIBUTE_NORMAL+FILE_FLAG_SEQUENTIAL_SCAN,0
	cmp eax,-1
	mov [lastcompiniterror],errorA
	    jz CompressInitError
	mov [source_file_handle],eax

	invoke GetFileSize,eax,0
	cmp eax,-1
	mov [lastcompiniterror],errorC
	    jz CompressInitError
	mov [source_file_size],eax

	cmp eax,sizeof.DIBDUMPHEADER   ;(size)
	mov [lastcompiniterror],errorD
	    jb CompressInitError

	invoke SetFilePointer,[source_file_handle],0,0,FILE_BEGIN
	cmp eax,-1
	mov [lastcompiniterror],error8
	    jz CompressInitError

	mov edx,sizeof.DIBDUMPHEADER
	invoke ReadFile,[source_file_handle],dibfileheader,edx,bytesread_temp,0
	test eax,eax
	mov [lastcompiniterror],error9
	     jz CompressInitError

;test file integrity via size

	cmp DWORD [dibfileheader.AtxDIBId],'ATXR'
	mov [lastcompiniterror],errorD
	     jnz CompressInitError

	cmp [dibfileheader.HeaderSize],sizeof.DIBDUMPHEADER
	mov [lastcompiniterror],errorD
	    jb CompressInitError

	mov eax,[dibfileheader.BitmapData.biWidth]
	mov ecx,[dibfileheader.BitmapData.biHeight]
	mul ecx
	xor ecx,ecx
	mov cx,[dibfileheader.BitmapData.biBitCount]
	shr ecx,3
	mul ecx
	test eax,eax
	mov [vrdef_bufsize],eax
	     jz CompressInitError

	mov ecx,[dibfileheader.DiffFrameCount]
	mul ecx
	add eax,[dibfileheader.DiffFrameCount]		;for frame repeat count buffer size
	add eax,[dibfileheader.HeaderSize]
	cmp eax,[source_file_size]
	mov [lastcompiniterror],errorE
	     jnz CompressInitError

	mov eax,[dibfileheader.FrameRepeatTableFileOffset]
	push [dibfileheader.FrameRepeatTableFileOffsetHigh]
	;cmp eax,[dibfileheader.HeaderSize]
	;mov [lastcompiniterror],errorF
	;    jb CompressInitError
	mov edx,esp
	invoke SetFilePointer,[source_file_handle],eax,edx,FILE_BEGIN
	add esp,4

	cmp eax,-1
	mov [lastcompiniterror],error8
	    jz CompressInitError

	invoke LocalAlloc,LPTR,[dibfileheader.DiffFrameCount]
	test eax,eax
	mov [lastcompiniterror],error7
	     jz CompressInitError
	mov [framerepeatcount_BUF],eax

;READ FRAME REPEAT BUFFER FROM END OF DIB DUMP
	invoke ReadFile,[source_file_handle],eax,[dibfileheader.DiffFrameCount],bytesread_temp,0
	test eax,eax
	mov [lastcompiniterror],error9
	     jz CompressInitError

	mov eax,[vrdef_bufsize]
	mov ecx,VALLOCFRAMECOUNT
	mul ecx
	mov [valloc_bufsize],eax
	invoke VirtualAlloc,0,eax,MEM_COMMIT+MEM_RESERVE,PAGE_READWRITE
	test eax,eax
	mov [lastcompiniterror],error6
	    jz CompressInitError
	mov [dibtempbufferaddr],eax
	add eax,[valloc_bufsize]
	mov [valloc_end_ptr],eax	;points to end of valloc buffer
	mov [valloc_index_ptr],eax	;-> on first frame, will read into buffer

;set uncompressed stream's initial AVI specs
	mov [avi_create_info.fccType],'vids'			;FOURCC code
	;mov [avi_create_info.fccHandler],0
	mov [avi_create_info.dwQuality],10000
	mov [avi_create_info.dwScale],1
	    mov eax,[dibfileheader.Framerate]
	    cmp eax,0
	    mov [lastcompiniterror],errorJ
		jng CompressInitError
	mov [avi_create_info.dwRate],eax
	    mov eax,[dibfileheader.BitmapData.biWidth]
	mov [avi_create_info.rcFrame.right],eax
	    mov eax,[dibfileheader.BitmapData.biHeight]
	mov [avi_create_info.rcFrame.bottom],eax		;values are unimportant
	    mov eax,[vrdef_bufsize]
	mov [avi_create_info.dwSuggestedBufferSize],eax

;renamed REC file extension to AVI and delete if existing
	mov edx,source_file_nameonly
	FINDSTRINGEND edx
	mov DWORD [edx-4],'.avi'

	invoke DeleteFile,source_file_nameonly

;open final AVI file and create initial stream (uncompressed)
	invoke AVIFileOpen,avifile_handle,source_file_nameonly,OF_CREATE+OF_READWRITE,0
	test eax,eax
	mov [lastcompiniterror],error5
	    jnz CompressInitError

	invoke AVIFileCreateStream,[avifile_handle],avistream_handle_orig,avi_create_info
	test eax,eax
	mov [lastcompiniterror],error4
	    jnz CompressInitError

;reset AVICOMPRESSOPTIONS struc
	call ResetAVICompressOptions

;show Compression Options dialog
	invoke AVISaveOptions,[hwnd],ICMF_CHOOSE_DATARATE,1,\
			avistream_handle_orig,avi_compress_opts_addr
	or [saveoptionsrunonce],1
	cmp eax,TRUE
	mov [lastcompiniterror],error3
	    jnz CompressInitError

	invoke AVIMakeCompressedStream,avistream_handle,[avistream_handle_orig],\
			avi_compress_opts,0
	test eax,eax
	mov [lastcompiniterror],error2
	    jnz CompressInitError

	invoke AVIStreamSetFormat,[avistream_handle],0,dibfileheader.BitmapData,\
				[dibfileheader.BitmapData.biSize]
	test eax,eax
	mov [lastcompiniterror],error1
	    jnz CompressInitError

;set file reading to after file header (to DIB data)
	invoke SetFilePointer,[source_file_handle],[dibfileheader.HeaderSize],0,FILE_BEGIN
	cmp eax,-1
	mov [lastcompiniterror],error8
	    jz CompressInitError

	mov [encodestate_ptr],encodingtext
	mov [estateparam1],source_file_nameonly
	mov [estateparam2],0
	    mov eax,[dibfileheader.TrueFrameCount]
	mov [estateparam3],eax
	mov [DiffFrameCount_current],0
	mov [TrueFrameCount_current],0

;INVERT SAVE FLAGS IF APPLICABLE
	cmp [dibfileheader.BitmapData.biBitCount],16
	    jnz NoChangeInvertFlag_B
	cmp [dibfileheader.SaveFlags],'ECDF'
	    jz NoChangeInvertFlag_B
	    mov eax,[PreComp_XORMASK]
	    xor [dibfileheader.SaveFlags],eax
	NoChangeInvertFlag_B:

;change 'select' button message
	invoke SendMessage,[btopenhandle],WM_SETTEXT,0,openbttext2

;reset progress bar
	invoke SendMessage,[progbarhandle],PBM_SETPOS,0,0

;update encoding and file info in window
	invoke InvalidateRect,[hwnd],textrect2,TRUE    ;encoding status region
	invoke InvalidateRect,[hwnd],textrect3,TRUE    ;file info region
	invoke UpdateWindow,[hwnd]

	mov [is_encoding],TRUE
	xor eax,eax
	ret 16

;=================================================================
CompressInitError:
;=================================================================
	call ReleaseAllBuffers
	invoke MessageBox,[hwnd],[lastcompiniterror],errormsgtitle,0
	xor eax,eax
	ret 16

;=================================================================
CompressInitErrorMsgLoop:
;=================================================================
	call ReleaseAllBuffers
	invoke MessageBox,[hwnd],[lastcompiniterror],errormsgtitle,0
	jmp MsgLoopMain

;=================================================================
ResetAVICompressOptions:
;=================================================================
	push edi
	mov edi,avi_compress_opts+4
	xor eax,eax
	mov ecx,10
	rep stosd
	pop edi
	mov [avi_compress_opts.fccType],'vids'
	ret

;=================================================================
ReleaseAllBuffers:
;=================================================================
	mov [is_encoding],FALSE
	cmp [saveoptionsrunonce],0
	    jz nosaveoptionsrelease
	invoke AVISaveOptionsFree,1,avi_compress_opts_addr
	and [saveoptionsrunonce],0
	nosaveoptionsrelease:
	RCALL AVIStreamRelease,[avistream_handle]
	RCALL AVIStreamRelease,[avistream_handle_orig]
	RCALL AVIFileRelease,[avifile_handle]
	VIRTUALRELEASE [dibtempbufferaddr],[valloc_bufsize]
	LOCALRELEASE [framerepeatcount_BUF]
	RCALL CloseHandle,[source_file_handle]
	invoke SendMessage,[btopenhandle],WM_SETTEXT,0,openbttext1
	ret

;=================================================================
EndVideoCompression:
;=================================================================
	call ReleaseAllBuffers
	push ebx
	push ebp
	mov ebp,esp
	sub esp,150

	mov [encodestate_ptr],successtext
	mov [estateparam1],source_file_nameonly

	invoke InvalidateRect,[hwnd],textrect2,TRUE    ;required for WM_PAINT to be sent via UpdateWindow
	invoke UpdateWindow,[hwnd]

	mov esp,ebp
	pop ebp
	pop ebx
	jmp MsgLoopMain

;=================================================================
section '.data' data readable writeable
;=================================================================

wc		WNDCLASSEX
wndclassname	db	"ATXRECCompressClass",0
btclassname	db	"BUTTON",0
pbclassname	db	"msctls_progress32",0
wndname 	db	"ATX Trespasser REC cheat video compressor",0
hInstance	dd	0
hwnd		dd	0
msgbuf		MSG
psbuf		PAINTSTRUCT
textrect1	RECT
textrect2	RECT
textrect3	RECT
btexithandle	dd	0
btopenhandle	dd	0
progbarhandle	dd	0
exitbttext	db	"Exit",0
openbttext1	db	"Select file",0
openbttext2	db	"Cancel encoding",0

nofiletext	db	"Please select a REC data file to encode to AVI format",0
encodingtext	db	"Encoding file: %s (frame %u of %u)",0
successtext	db	"File successfully encoded as: %s",0
errormsgtitle	db	"REC file compression",0
nomsgtext	db	"   ",0
encodestate_ptr dd	nomsgtext
estateparam1	dd	0
estateparam2	dd	0
estateparam3	dd	0
fileinfostring	db	"Last Video File Info",0Dh,0Ah
		db	"Resolution: %u x %u",0Dh,0Ah
		db	"Bits Per Pixel: %u",0Dh,0Ah
		db	"Framerate: %u fps",0Dh,0Ah
		db	"Total Frames: %u",0Dh,0Ah
		db	"Total Frame Repetitions: %u",0Dh,0Ah
		db	"Known recording errors: %u",0Dh,0Ah
		db	"Estimated Length: %u seconds",0Dh,0Ah
		db	"Raw DIB Uncompressed Size: %u bytes",0Dh,0Ah
		db	"5-6-5 to 5-5-5 16 BPP format: %s",0Dh,0Ah
		db	"To be inverted (top-down): %s",0Dh,0Ah
		db	0

STRING_YES	db	"yes",0
STRING_NO	db	"no",0
STRING_N_A	db	"n/a",0

msgbox_caption	db	"REC Compression Options",0

error1		db	"Unable to set compressed stream format.",0
error2		db	"Unable to make compressed stream.",0
error3		db	"Save options dialog cancelled.",0
error4		db	"Unable to create original uncompressed stream.",0
error5		db	"Unable to create AVI file.",0
error6		db	"Unable to allocate main virtual memory DIB buffer.",0
error7		db	"Unable to allocate frame repeat count buffer.",0
error8		db	"Unable to set file pointer for REC data file.",0
error9		db	"Unable to read REC data file.",0
errorA		db	"Unable to open REC data file.",0
errorB		db	"REC file selection cancelled.",0
errorC		db	"Unable to get REC file size.",0
errorD		db	"Invalid REC file header",0
errorE		db	"Invalid REC file size",0
errorF		db	"Invalid REC file frame repeat buffer location",0
errorG		db	"Video encoding cancelled",0
errorH		db	"Error writing to AVI file stream",0
errorI		db	"Error reading REC file data during encoding",0
errorJ		db	"Invalid REC file framerate",0

lastcompiniterror	dd	0

avistream_handle	dd	0
avistream_handle_orig	dd	0
avifile_handle		dd	0
framerepeatcount_BUF	dd	0
dibtempbufferaddr	dd	0
source_file_handle	dd	0
source_file_size	dd	0

is_encoding		db	0
DiffFrameCount_current	dd	0
TrueFrameCount_current	dd	0
saveoptionsrunonce	db	0
bytesread_temp		dd	0
vrdef_bufsize		dd	0
valloc_bufsize		dd	0
valloc_index_ptr	dd	0
valloc_end_ptr		dd	0


avi_create_info 	AVISTREAMINFO

avi_compress_opts_addr	dd	avi_compress_opts
avi_compress_opts	AVICOMPRESSOPTIONS

OFN_info		OPENFILENAME
filter_strings	     db      "REC DIB dump data files",0,"*.rec",0,0
default_extension    db      "rec",0
open_file_caption    db      "ATX REC compressor - choose file",0

source_file		db	512 dup 0
source_file_nameonly	db	256 dup 0

dibfileheader		DIBDUMPHEADER

Blue16_MMX_Mask 	dq	0001F001F001F001Fh
Blue16_MMX_Mask_Erase	dq	07FE07FE07FE07FE0h


section_videorecording	    db	    "VideoRecording",0
key_invertatcomp	    db	    "InvertAtComp",0
ininame_buffer		    db	    512 dup ?
PreComp_XORMASK 	    dd	    0

;=================================================================
section '.idata' import data readable writeable
;=================================================================
  library kernel,"KERNEL32.DLL",\
	  user32,"USER32.DLL",\
	  gdi32,"GDI32.DLL",\
	  avifil32,'AVIFIL32.DLL',\
	  comctl32,'COMCTL32.DLL',\
	  comdlg,'COMDLG32.DLL'

  import kernel,\
	 CloseHandle,"CloseHandle",\
	 CopyFile,"CopyFileA",\
	 CreateFile,"CreateFileA",\
	 DeleteFile,'DeleteFileA',\
	 ExitProcess,"ExitProcess",\
	 FreeLibrary,"FreeLibrary",\
	 GetCurrentProcessId,"GetCurrentProcessId",\
	 GetModuleFileName,"GetModuleFileNameA",\
	 GetModuleHandle,"GetModuleHandleA",\
	 GetFileSize,"GetFileSize",\
	 GetLastError,"GetLastError",\
	 GetPrivateProfileInt,"GetPrivateProfileIntA",\
	 GetProcAddress,"GetProcAddress",\
	 LoadLibrary,"LoadLibraryA",\
	 LocalAlloc,"LocalAlloc",\
	 LocalFree,"LocalFree",\
	 LocalReAlloc,"LocalReAlloc",\
	 LocalSize,"LocalSize",\
	 ReadFile,"ReadFile",\
	 SetFileAttributes,"SetFileAttributesA",\
	 SetFilePointer,"SetFilePointer",\
	 VirtualAlloc,'VirtualAlloc',\
	 VirtualFree,'VirtualFree',\
	 WriteFile,"WriteFile"

  import user32,\
	 BeginPaint,'BeginPaint',\
	 DefWindowProc,"DefWindowProcA",\
	 DestroyWindow,"DestroyWindow",\
	 DispatchMessage,"DispatchMessageA",\
	 CloseWindow,"CloseWindow",\
	 CreateWindowEx,"CreateWindowExA",\
	 DrawText,'DrawTextA',\
	 EndPaint,'EndPaint',\
	 GetActiveWindow,"GetActiveWindow",\
	 GetDesktopWindow,"GetDesktopWindow",\
	 InvalidateRect,'InvalidateRect',\
	 LoadCursor,"LoadCursorA",\
	 LoadIcon,"LoadIconA",\
	 MessageBox,"MessageBoxA",\
	 PeekMessage,"PeekMessageA",\
	 PostQuitMessage,"PostQuitMessage",\
	 RedrawWindow,"RedrawWindow",\
	 RegisterClassEx,"RegisterClassExA",\
	 SendMessage,"SendMessageA",\
	 SetFocus,"SetFocus",\
	 SetForegroundWindow,"SetForegroundWindow",\
	 ShowWindow,"ShowWindow",\
	 TranslateMessage,"TranslateMessage",\
	 UpdateWindow,"UpdateWindow",\
	 wsprintf,"wsprintfA"

  import gdi32,\
	 SetBkMode,'SetBkMode',\
	 SetTextColor,'SetTextColor'

  import avifil32,\
	 AVIFileCreateStream,"AVIFileCreateStreamA",\
	 AVIFileExit,"AVIFileExit",\
	 AVIFileInit,"AVIFileInit",\
	 AVIFileOpen,"AVIFileOpenA",\
	 AVIFileRelease,"AVIFileRelease",\
	 AVIMakeCompressedStream,"AVIMakeCompressedStream",\
	 AVISaveOptions,"AVISaveOptions",\
	 AVISaveOptionsFree,"AVISaveOptionsFree",\
	 AVIStreamRelease,"AVIStreamRelease",\
	 AVIStreamSetFormat,"AVIStreamSetFormat",\
	 AVIStreamWrite,"AVIStreamWrite",\
	 CreateEditableStream,"CreateEditableStream"


  import comctl32,\
	 InitCommonControls,'InitCommonControls'

  import comdlg,\
	 GetOpenFileName,'GetOpenFileNameA'

;=================================================================
section '.rsrc' resource data readable
;=================================================================

	directory RT_VERSION,versions

	resource versions,\
	   1,LANG_NEUTRAL,version

	versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,\
				LANG_ENGLISH+SUBLANG_DEFAULT,0,\
	  'FileDescription','ATX Trespasser REC compress utility',\
	  'LegalCopyright','Free, open source.',\
	  'FileVersion',RECCOMPRESS_VERSION,\
	  'ProductVersion',RECCOMPRESS_VERSION,\
	  'OriginalFilename','RECCOMPRESS.EXE'

